###############################################################################
# Profile.pl                                                                  #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$profileplver = "1 Gold - SP 1.3";

require "$sourcedir/StealthMail.pl";

sub ModifyProfile {
fopen(FILE, "$memberdir/$INFO{'username'}.mod");
@mdfile = <FILE>;
fclose(FILE);
fopen(FILE, "$memberdir/$INFO{'username'}.rst");
@mrstfile = <FILE>;
fclose(FILE);
	if ($INFO{'username'} =~ m~/~){ &fatal_error($txt{'224'}); }
	if ($INFO{'username'} =~ m~\\~){ &fatal_error($txt{'225'}); }
	if($username ne $INFO{'username'} && $settings[7] ne 'Administrator') { &fatal_error($txt{'80'}); }
	if(!-e ("$memberdir/$INFO{'username'}.dat")){ &fatal_error("$txt{'453'} -- $INFO{'username'}"); }
	if($allowpics) {
		opendir(DIR, "$facesdir") || fatal_error("$txt{'230'} ($facesdir)! $txt{'681'}");
		closedir(DIR);
	}

	fopen(FILE, "$memberdir/$INFO{'username'}.title");
	@titlesettings=<FILE>;
	fclose(FILE);
	fopen(FILE, "$memberdir/$INFO{'username'}.dat");
	@memsettings=<FILE>;
	fclose(FILE);
	foreach (@memsettings) { $_ =~ s~[\n\r]~~g; }
	$dr = $memsettings[14] ? $memsettings[14] : $txt{'470'};
	if ($memsettings[11] eq 'Male') { $GenderMale = ' selected'; }
	if ($memsettings[11] eq 'Female') { $GenderFemale = ' selected'; }
	$signature = $memsettings[5];
	$signature =~ s/\&\&/\n/g;
	$signature =~ s/\&lt;/</g;
	$signature =~ s/\&gt;/>/g;
	&CalcAge("parse"); # Let's get the birthdate
	$memsettings[9] =~ tr/+/ /;
	$memsettings[10] =~ tr/+/ /;
	my($maptest);
	if($memsettings[15] ne "") {
		$maptest = substr($memsettings[15],0,2);
	}

	if ($memsettings[17] == 6) { $tsl6 = ' selected'; }
	elsif ($memsettings[17] == 5) { $tsl5 = ' selected'; }
	elsif($memsettings[17] == 4) { $tsl4 = ' selected'; }
	elsif ($memsettings[17] == 3) { $tsl3 = ' selected'; }
	elsif ($memsettings[17] == 2) { $tsl2 = ' selected'; }
	elsif ($memsettings[17] == 1) { $tsl1 = ' selected'; }
	elsif ($timeselected == 6) { $tsl6 = ' selected'; }
	elsif ($timeselected == 5) { $tsl5 = ' selected'; }
	elsif ($timeselected == 4) { $tsl4 = ' selected'; }
	elsif ($timeselected == 3) { $tsl3 = ' selected'; }
	elsif ($timeselected == 2) { $tsl2 = ' selected'; }
	else { $tsl1 = ' selected'; }

	$selectyear = '';
	$seluyear = qq~$txt{'566'}<select name="bday3" style="font-size=10pt;"><option value="">  </option>\n~;
	for ($e = 1905; $e < ($year-4); $e++) {
		if($uyear == $e) {$selectyear = 'selected';} else {$selectyear = '';}
		$seluyear .= qq~<option value="$e" $selectyear>$e</option>\n~;
	}
	$seluyear .= qq~</select> ~;

	$selectmnth = '';
	$dayormonthm = qq~$txt{'564'}<select name="bday1" style="font-size=10pt;"><option value="">  </option>\n~;
	for ($b = 1; $b < 13; $b++) {
		if($umonth == $b) {$selectmnth = 'selected';} else {$selectmnth = '';}
		if($b < 10) {$c = "0$b";} else { $c = $b;}
		$dayormonthm .= qq~<option value="$c" $selectmnth>$c</option>\n~;
	}
	$dayormonthm .= qq~</select> ~;

	$selectday = '';
	$dayormonthd = qq~$txt{'565'}<select name="bday2" style="font-size=10pt;"><option value="">  </option>\n~;
	for ($a = 1; $a < 32; $a++) {
		if($uday == $a) {$selectday = 'selected';} else {$selectday = '';}
		if($a < 10) {$d = "0$a";} else { $d = $a;}
		$dayormonthd .= qq~<option value="$d" $selectday>$d</option>\n~;
	}
	$dayormonthd .= qq~</select> ~;

	if ($tsl2 || $tsl3 || $tsl6) {$dayormonth=$dayormonthd.$dayormonthm;} else {$dayormonth=$dayormonthm.$dayormonthd;}

	$oldformat = $date;
	$oldmonth = substr($oldformat,0,2);
	$oldday = substr($oldformat,3,2);
	$oldyear = ("20".substr($oldformat,6,2)) - 1900;
	$oldhour = substr($oldformat,-8,2);
	$oldminute = substr($oldformat,-5,2);
	$oldsecond = substr($oldformat,-2,2);
	use Time::Local 'timelocal';
	eval { $oldtime = timelocal($oldsecond,$oldminute,$oldhour,$oldday,$oldmonth-1,$oldyear); };
	my ($psec,$pmin,$phour,$dummy,$dummy,$dummy,$dummy,$dummy,$dummy) = localtime($oldtime);
	if ($phour < 10) { $phour = "0$phour" };
	if ($pmin < 10) { $pmin = "0$pmin" };
	if ($psec < 10) { $psec = "0$psec" };
	$proftime = $phour.":".$pmin.":".$psec;
	$ampm = $phour > 11 ? 'pm' : 'am';
	$phour = $phour % 12 || 12;
	$proftime = qq~$phour:$pmin:$psec$ampm~;
	my( @imconfig, $sel0, $sel1 );
	if (-e("$memberdir/$INFO{'username'}.imconfig")) {
		fopen(FILE, "$memberdir/$INFO{'username'}.imconfig");
		@imconfig = <FILE>;
		fclose(FILE);
	}
	$imconfig[0] =~ s/[\n\r]//g;
	$imconfig[0] =~ s/\|/\n/g;
	$imconfig[1] =~ s/[\n\r]//g;
	if ($imconfig[1]) {
		$sel0='';
		$sel1=' selected';
	} else {
		$sel0=' selected';
		$sel1='';
	}

	$yymain .= qq~
<form action="$cgi;action=profile2" method="POST" name="creator">
<table border=0 width=720 cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}" height="30">
    &nbsp;<img src="$imagesdir/profile.gif" alt="" border="0">&nbsp;
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'79'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" height="25"><BR><font size="1">$txt{'698'}</font><BR><BR></td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25"><font size=2><b>$txt{'517'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
    <table border=0 width="100%" cellpadding="3">
      <tr>
	<td width="320"><font size=2><b>$txt{'35'}: </b></font></td>
	<td><font size=2><input type="hidden" name="username" value="$INFO{'username'}">$INFO{'username'}</font></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'81'}: </b></font><BR>
	<font size="1">$txt{'596'}</font></td>
	<td><input type="password" maxlength="30" name="passwrd1" size="20" value="$memsettings[0]"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'82'}: </b></font></td>
	<td><input type="password" maxlength="30" name="passwrd2" size="20" value="$memsettings[0]"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'68'}: </b></font><BR>
	<font size="1">$txt{'518'}</font></td>
	<td><input type="text" maxlength="30" name="name" size="30" value="$memsettings[1]"><input type="hidden" name="oldname" value="$memsettings[1]"></td>
      </tr><tr>
	<td width="320"><font size="2"><b>$txt{'69'}: </b></font><br>
        <font size="1">$txt{'679'}</font></td>
	<td><input type="text" maxlength="40" name="email" size="30" value="$memsettings[2]"><input type="hidden" name="oldemail" value="$memsettings[2]"></td>
      </tr>
~;
require "$sourcedir/ExtendedProfiles.pl";
$yymain .= ext_editprofile($INFO{'username'},"required") . qq~
    </table><br>
    </font></td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25"><font size=2><b>$txt{'597'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <table border=0 width="100%" cellpadding="3">
~;
$yymain .= ext_editprofile($INFO{'username'},"additional") . qq~
      <tr>
	<td width="320"><font size=2><b>$txt{'231'}: </b></font></td>
	<td>
	<select name="gender" size="1">
	 <option value=""></option>
	 <option value="Male"$GenderMale>$txt{'238'}</option>
	 <option value="Female"$GenderFemale>$txt{'239'}</option>
	</select>
	</td>
      </tr><tr>
          	<td width="320"><font size=2><b>$txtrst{'0'}:</b></font><br></td>
	<td><font size=2><select name="relation">
                <option selected>  $mrstfile[0]   </option>
                <option>$txtrst{'00'}</option>
                <option>$txtrst{'1'}</option>
                <option>$txtrst{'2'}</option>
                <option>$txtrst{'3'}</option>
                <option>$txtrst{'4'}</option>
                <option>$txtrst{'5'}</option>
                <option>$txtrst{'6'}</option>
                <option>$txtrst{'7'}</option>
                <option>$txtrst{'8'}</option>
                <option>$txtrst{'9'}</option>
                <option>$txtrst{'10'}</option>
                <option>$txtrst{'11'}</option>
               </select></font></td>
            </tr><tr>
 	<td width="320"><font size=2><b>$modtxt{'1'} :</b></font><br><font size=1>$modtxt{'0'}.</font></td>
	<td><font size=2><select name="mood">
		<option selected>  $mdfile[0]   </option>
		<option>$modtxt{'10'}</option>
		<option>$modtxt{'1a'}</option>
		<option>$modtxt{'1b'}</option>
		<option>$modtxt{'1c'}</option>
		<option>$modtxt{'1d'}</option>
		<option>$modtxt{'1e'}</option>
		<option>$modtxt{'1f'}</option>
		<option>$modtxt{'1g'}</option>
		<option>$modtxt{'1h'}</option>
		<option>$modtxt{'1i'}</option>
		<option>$modtxt{'1j'}</option>
		<option>$modtxt{'1k'}</option>
		<option>$modtxt{'1l'}</option>
		<option>$modtxt{'1m'}</option>
		<option>$modtxt{'1n'}</option>
		<option>$modtxt{'1o'}</option>
		<option>$modtxt{'1p'}</option>
		<option>$modtxt{'1q'}</option>
		<option>$modtxt{'1r'}</option>
		<option>$modtxt{'1s'}</option>
		<option>$modtxt{'1t'}</option>
		<option>$modtxt{'1u'}</option>
		<option>$modtxt{'1v'}</option>
		<option>$modtxt{'1w'}</option>
		<option>$modtxt{'1x'}</option>
		<option>$modtxt{'1y'}</option>
		<option>$modtxt{'1z'}</option>
		<option>$modtxt{'11'}</option>
		<option>$modtxt{'12'}</option>
		<option>$modtxt{'13'}</option>
		<option>$modtxt{'14'}</option>
		<option>$modtxt{'15'}</option>
		<option>$modtxt{'16'}</option>
		<option>$modtxt{'17'}</option>
		<option>$modtxt{'18'}</option>
		<option>$modtxt{'19'}</option>
		<option>$modtxt{'20'}</option>
		<option>$modtxt{'21'}</option>
		<option>$modtxt{'22'}</option>
		<option>$modtxt{'23'}</option>
		<option>$modtxt{'24'}</option>
		<option>$modtxt{'25'}</option>
		<option>$modtxt{'26'}</option>
		<option>$modtxt{'27'}</option>
		<option>$modtxt{'28'}</option>
		<option>$modtxt{'29'}</option>
		<option>$modtxt{'30'}</option>
		<option>$modtxt{'31'}</option>
		<option>$modtxt{'32'}</option>
		<option>$modtxt{'33'}</option>
		<option>$modtxt{'34'}</option>
		<option>$modtxt{'35'}</option>
		<option>$modtxt{'36'}</option>
               </select></font></td>
     </tr><tr>
	<td width="320"><font size=2><b>$txt{'563'}:</b></font></td>
	<td><font size="1">$dayormonth$seluyear</font></td>
      </tr><tr>
~;
if($maptest eq "x0") {

	my($loccode, $proflocal, $profcountry, $profcontin, $profx, $profy, $profstate);
	($loccode, $proflocal, $profcountry, $profcontin, $profx, $profy, $profstate) = split(/\|/, $memsettings[15]);

	fopen(FILE, "$vardir/country.txt");
	@country = <FILE>;
	fclose(FILE);
	chomp @country;
		foreach $curcountry (sort @country) {
			$curcountry =~ s/ //gi;
			$curcountry =~ s/\n//gi;
			$curcountry =~ s/\r//gi;
			$selektet = "";
			if($curcountry eq $profcountry) { $selektet = ' selected' }
			$thevalue = $curcountry;
			$theopt = $curcountry;
			$theopt =~ s/\_/ /g;
			$cntropt .= qq~<option value="$thevalue"$selektet>$theopt\n~;
		}

	if($profcountry eq "") { $thisflag = "Noflag" }
	else { $thisflag = $profcountry }

	fopen(FILE, "$vardir/state.txt");
	@state = <FILE>;
	fclose(FILE);
	chomp @state;
	foreach $curstate (@state) {
		$curstate =~ s/ //gi;
		$curstate =~ s/\n//gi;
		$curstate =~ s/\r//gi;
		$selektet = "";
		($stateval, $stateopt) = split(/\,/, $curstate);
		if($profstate eq $curstate) { $selektet = ' selected' }
		$stateopt =~ s/\_/ /g;
		if($stateval eq "xxx") {
			$statopt .= qq~<option value="">\n~;
			$statopt .= qq~<option value="">$stateopt\n~;
			$statopt .= qq~<option value="">---------------\n~;
		}
		else { $statopt .= qq~<option value="$curstate"$selektet>$stateopt\n~; }
	}

	$yymain .= qq~
	<td width="320"><font size=2><b>$maptxt{'03'}: </b></font></td>
	<td><font size=2><input style="font-size: 9pt;" type="text" maxlength="30" name="cityloc" size="24" value="$proflocal"></font></td>
      </tr>
	~;
	if($view_state) {
		$yymain .= qq~
		<tr>
		<td width="320"><font size=2><b>$maptxt{'21'}: </b></font></td>
		<td><font size=2><select style="font-size: 9pt;" name="mapstate"><option value="">$statopt</select></font></td>
	      </tr>
		~;
	}
	$yymain .= qq~
	<tr>
	<td width="320"><font size=2><b>$maptxt{'04'}: </b></font></td>
	<td>

	<script language="JavaScript1.2" type="text/javascript">
	<!--
	function showflag() {
	   document.images.flags.src="$imagesdir/flag/"+document.creator.mapcountry.options[document.creator.mapcountry.selectedIndex].value+".gif";
	}
	//-->
	</script>

	<font size=2><select style="font-size: 9pt;" name="mapcountry" onChange="showflag()"><option value="Noflag">$cntropt</select></font><img src="$imagesdir/flag/$thisflag.gif" name="flags" border=0 hspace=15>
	<input type="hidden" name="kode" value="$loccode">

	<input type="hidden" name="contselect" value="$profcontin">
	<input type="hidden" name="xcoord" value="$profx">
	<input type="hidden" name="ycoord" value="$profy"></td>
      </tr><tr>
~;

}
elsif($maptest eq "x1") {
	my($loccode, $proflocal, $profcountry, $profcontin, $profx, $profy, $profstate, $initstate, $namestate, $viewloc);
	($loccode, $proflocal, $profcountry, $profcontin, $profx, $profy, $profstate) = split(/\|/, $memsettings[15]);
	$thiscountry = $profcountry;
	$thiscountry =~ s/\_/ /g;
	($initstate, $namestate) = split(/\,/, $profstate);
	my($prlocal, $inistate);
	if($proflocal ne "") { $prlocal .= qq~$proflocal,~; } else { $prlocal = ""; }
	if($initstate ne "") { $inistate .= qq~$initstate,~; } else { $inistate = ""; }
	$viewloc = qq~$prlocal $inistate $thiscountry~;

	$yymain .= qq~
	<td width="320"><font size=2><b>$txt{'227'}:</b> $maptxt{'11'}</font></td>
	<td><font size=2>$viewloc</font><img src="$imagesdir/flag/$profcountry.gif" border=0 hspace=15>
	<input type="hidden" name="kode" value="$loccode">
	<input type="hidden" name="cityloc" value="$proflocal">
	~;
	if($view_state) {
		$yymain .= qq~
		<input type="hidden" name="mapstate" value="$profstate">
		~;
	}
	$yymain .= qq~
	<input type="hidden" name="mapcountry" value="$profcountry">
	<input type="hidden" name="contselect" value="$profcontin">
	<input type="hidden" name="xcoord" value="$profx">
	<input type="hidden" name="ycoord" value="$profy"></td>
      </tr><tr>
~;
}
else {
	my($loccode, $profcontin, $profx, $profy, $profstate);

	fopen(FILE, "$vardir/country.txt");
	@country = <FILE>;
	fclose(FILE);
	chomp @country;
		foreach $curcountry (sort @country) {
			$curcountry =~ s/ //gi;
			$curcountry =~ s/\n//gi;
			$curcountry =~ s/\r//gi;
			$selektet = "";
			$thevalue = $curcountry;
			$theopt = $curcountry;
			$theopt =~ s/\_/ /g;
			$cntropt .= qq~<option value="$thevalue"$selektet>$theopt\n~;
		}
	if($view_state) {
		fopen(FILE, "$vardir/state.txt");
		@state = <FILE>;
		fclose(FILE);
		chomp @state;
			foreach $curstate (@state) {
				$curstate =~ s/ //gi;
				$curstate =~ s/\n//gi;
				$curstate =~ s/\r//gi;
				($stateval, $stateopt) = split(/\,/, $curstate);
				$stateopt =~ s/\_/ /g;
				if($stateval eq "xxx") {
					$statopt .= qq~<option value="">\n~;
					$statopt .= qq~<option value="">$stateopt\n~;
					$statopt .= qq~<option value="">---------------\n~;
				}
				else { $statopt .= qq~<option value="$curstate">$stateopt\n~; }
			}
	}

	$thisflag = "Noflag";

	$yymain .= qq~
	<td width="320"><font size=2><b>$maptxt{'03'}: </b></font></td>
	<td><font size=2><input style="font-size: 9pt;" type="text" maxlength="30" name="cityloc" size="24"></font></td>
      </tr>
	~;
	if($view_state) {
		$yymain .= qq~
		<tr>
		<td width="320"><font size=2><b>$maptxt{'21'}: </b></font></td>
		<td><font size=2><select style="font-size: 9pt;" name="mapstate"><option value="">$statopt</select></font></td>
      	</tr>
		~;
	}
	$yymain .= qq~

	<tr>
	<td width="320"><font size=2><b>$maptxt{'04'}: </b></font></td>
	<td>
	<script language="JavaScript1.2" type="text/javascript">
	<!--
	function showflag() {
	   document.images.flags.src="$imagesdir/flag/"+document.creator.mapcountry.options[document.creator.mapcountry.selectedIndex].value+".gif";
	}
	//-->
	</script>
	<font size=2><select style="font-size: 9pt;" name="mapcountry" onChange="showflag()"><option value="Noflag">$cntropt</select></font><img src="$imagesdir/flag/$thisflag.gif" name="flags" border=0 hspace=15>
	<input type="hidden" name="kode" value="x0">

	<input type="hidden" name="contselect" value="$profcontin">
	<input type="hidden" name="xcoord" value="$profx">
	<input type="hidden" name="ycoord" value="$profy"></td>
      </tr><tr>
~;

}
	$yymain .= qq~
	<td colspan=2>
	<BR><hr width="100%" size="1" class="hr"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'83'}: </b></font><BR>
	<font size="1">$txt{'598'}</font></td>
	<td><font size=2><input type=text maxlength="30" name=websitetitle size=50 value="$memsettings[3]"></font></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'84'}: </b></font><BR>
	<font size="1">$txt{'599'}</font></td>
	<td><font size=2><input type=text name=websiteurl size=50 value="$memsettings[4]"></font></td>
      </tr><tr>
	<td colspan=2>
	<BR><hr width="100%" size="1" class="hr"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'513'}: </b></font><BR>
	<font size="1">$txt{'600'}</font></td>
	<td><font size=2><input type=text maxlength="10" name=icq size=20 value="$memsettings[8]"></font></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'603'}: </b></font><BR>
	<font size="1">$txt{'601'}</font></td>
	<td><font size=2><input type=text maxlength="30" name=aim size=20 value="$memsettings[9]"></font></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'604'}: </b></font><BR>
	<font size="1">$txt{'602'}</font></td>
	<td><font size=2><input type=text maxlength="30" name=yim size=20 value="$memsettings[10]"></font></td>
	</tr>
~;
	fopen(FILE, "$memberdir/$INFO{'username'}.om", 1);
		@msnsettings = <FILE>;
	fclose <FILE>;
$yymain .= qq~
	<tr>
	<td width="320"><font size="2"><b>$msntxt{'4'}: </b></font><br /><font size="1">$msntxt{'5'}</font></td>
	<td><font size="2"><input type="text" name="msn" size="20" value="$msnsettings[0]"></font></td>
      </tr><tr>
	<td colspan=2>
	<BR><hr width="100%" size="1" class="hr"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'228'}: </b></font></td>
	<td><font size=2><input type=text name=usertext size=50 value="$memsettings[12]" maxlength="50"></font></td>
      </tr>
~;
	if($allowpics) {
		opendir(DIR, "$facesdir") || fatal_error("$txt{'230'} ($facesdir)!<BR>$txt{'681'}");
		@contents = readdir(DIR);
		closedir(DIR);
		$images = "";
		foreach $line (sort @contents){
			($name, $extension) = split (/\./, $line);
			$checked = "";
			if ($line eq $memsettings[13]) { $checked = ' selected'; }
			if ($memsettings[13] =~ m~\Ahttp://~ && $line eq 'blank.gif') { $checked = ' selected'; }
			if ($extension =~ /gif/i || $extension =~ /jpg/i || $extension =~ /jpeg/i || $extension =~ /png/i ){
				if ($line eq 'blank.gif') { $name = $txt{'422'}; }
				$images .= qq~<option value="$line"$checked>$name\n~;
			}
		}
		if ($memsettings[13] =~ m~\Ahttp://~) {
			$pic = 'blank.gif';
			$checked = ' checked';
			$tmp = $memsettings[13];
		}
		else {
			$pic = $memsettings[13];
			$tmp = 'http://';
		}
		if (-e "$memberdir/$INFO{'username'}.siz") {
			fopen(FILE, "$memberdir/$INFO{'username'}.siz");
			@imagsize=<FILE>;
			fclose(FILE);
			foreach (@imagsize) { $_ =~ s~[\n\r]~~g; }
			$akt_width = $imagsize[0];
			$akt_height = $imagsize[1];
		}
		else {
			$akt_width = 65;
			$akt_height = 65;
		}

		$yymain .= qq~
      <tr>
	<td width="320"><font size="2"><b>$txt{'229'}:</b></font><br>
	<font size="1">$txt{'474'} $userpic_limits</font></td>
        <td>
        <script language="JavaScript1.2" type="text/javascript">
        function showimage()
        {
           if (!document.images) return;
           document.images.icons.src="$facesurl/"+document.creator.userpic.options[document.creator.userpic.selectedIndex].value;
        }
        </script>
        <select name="userpic" size=6 onChange="showimage()">$images</select>
        &nbsp;&nbsp;<img src="$facesurl/$pic" name="icons" border=0 hspace=15>
<br>
<script>
function faceswin() {
  window.open("$scripturl?action=faces", 'list', 'width=600,height=500, scrollbars=yes');
}
</script>
<a href=javascript:faceswin()>$facestxt{'3'}</a>
	</td>
      </tr><tr>
	<td width="320"><font size="2"><B>$txt{'475'}</B></font></td>
	<td><input type="checkbox" name="userpicpersonalcheck"$checked>
	<input type="text" name="userpicpersonal" size="45" value="$tmp"></td>
      </tr>
	<tr>
	<td width="320"> <font size="2"><B>$siztxt{'01'}</B></font> </td>
	<td>
	<input type="text" name="aktwidth" size="5" value="$akt_width"><font size="2"><B> x </B></font>
	<input type="text" name="aktheight" size="5" value="$akt_height"><font size="2"><B> pixel</B></font>
	</td>
      </tr>
~;
	}
	$yymain .= qq~
    </table><BR>
    </td>
~;
if($settings[7] eq 'Administrator' || $gballowset) {
$yymain .= qq~
    </td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25"><font size=2><b>$gsttxt{'1'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>

~;
	if(!-e ("$memberdir/$INFO{'username'}.gbs")) {
		fopen(FILE, ">$memberdir/$INFO{'username'}.gbs", 1);
			print FILE "checked\n";
			print FILE "$MaxGuestPosts\n";
			print FILE "$MaxGuestChars\n";
			print FILE "checked\n";
		fclose(FILE);
	}

	fopen(FILE, "$memberdir/$INFO{'username'}.gbs");
	@gbsettings=<FILE>;
	fclose(FILE);
	foreach (@gbsettings) { $_ =~ s~[\n\r]~~g; }

$yymain .= qq~

	<table border=0 cellpadding="3" width="100%" cellspacing="0">
		<tr>
			<td width="320"><font size="2"><b>$gsttxt{'11'}</b></font></td>
			<td><input type="checkbox" name="gbview" value="checked" $gbsettings[0]></td>
		</tr>
		~;
		if($gballowguest) {
		$yymain .= qq~
		<tr>
			<td width="320"><font size="2"><b>$gsttxt{'23'}</b></font></td>
			<td><input type="checkbox" name="gbguests" value="checked" $gbsettings[3]></td>
		</tr>
		~;
		}
		$yymain .= qq~
		<tr>
			<td width="320"><font size="2"><b>$gsttxt{'12'}</b></font> <font size="1">($gsttxt{'13'} $MaxGuestPosts)</font></td>
			<td><input type="text" maxlength="4" name="gbtotal" size="4" value="$gbsettings[1]"></td>
		</tr>
		<tr>
			<td width="320"><font size="2"><b>$gsttxt{'14'}</b></font> <font size="1">($gsttxt{'13'} $MaxGuestChars)</font></td>
			<td><input type="text" maxlength="4" name="gbchar" size="4" value="$gbsettings[2]"></td>
		</tr>
	</table>

    </td>
~;
}
else {
$yymain .= qq~
	<input type="hidden" name="gbview" value="checked">
	<input type="hidden" name="gbguests" value="checked">
	<input type="hidden" name="gbtotal" value="$MaxGuestPosts">
	<input type="hidden" name="gbchar" value="$MaxGuestChars">
~;
}
$yymain .= qq~
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25"><font size=2><b>$imtxt{'38'}</b></font></td><a name="userimcfg">
  </tr><tr>
  <td class="windowbg" bgcolor="$color{'windowbg'}">
    <table border=0>
     <tr>
      <td valign=top>
       <font size=2><b>$txt{'325'}:</b></font><br><font size="1">$txt{'326'}</font>
      </td>
      <td>
       <font size=2><textarea name=ignore rows=4 cols=50 wrap=virtual>$imconfig[0]</textarea></font>
      </td>
     </tr>~;
	if($enable_mailsounds) {
		# sounds hack
		chomp($imconfig[2]);

		opendir(DIR, "$soundsdir") || fatal_error("$txt{'230'} ($soundsdir)!<BR>$imtxt{'27'}");
		@contents = readdir(DIR);
		closedir(DIR);
		$sounds = "";
		if ($imconfig[2] eq "blank.wav" || $imconfig[2] eq "") { $sounds = qq~<option value="blank.wav"$checked selected>$imtxt{'28'}\n~; }
		else { $sounds = qq~<option value="blank.wav"$checked>$imtxt{'28'}\n~; }
		foreach $line (sort @contents) {
			chomp($line);
			($name, $extension) = split (/\./, $line);
			$checked = "";
			if ($line eq "$imconfig[2]") { $checked = ' selected'; }
				if($extension =~ /wav/i) {
				$sounds .= qq~<option value="$line"$checked>$name\n~;
				}
			}
	$yymain .= qq~
<bgsound id="sound">
<script language="JavaScript1.2" type="text/javascript">
<!--
function playSound() { document.all.sound.src = "$soundsurl/"+document.all.usersound.options[document.all.usersound.selectedIndex].value; }
//-->
</script>
		<tr><td width="320"><font size=2><b>$imtxt{'29'}:</b></font></td><td><select name="usersound" size="4" onChange="playSound()">$sounds</select></td></tr>~;
	} else { $yymain .= qq~<input type=hidden name="usersound" value="$imconfig[2]">~; }
if($enable_notification) {
	$yymain .= qq~
     <tr>
      <td valign=top>
       <font size=2><b>$txt{'327'}:</b></font>
      </td>
      <td>
       <font size=2>
	<select name="notify">
	 <option value="0"$sel0>$txt{'164'}
	 <option value="1"$sel1>$txt{'163'}
	</select>
       </font>
      </td>
     </tr>
~;
} else { $yymain .= qq~<input type=hidden name="notify" value="$imconfig[1]">~; }

	chomp($imconfig[4]);
	if($imconfig[4] eq "on") { $enable_imprev = 'checked'; }
	$yymain .= qq~<tr><td width="320"><font size=2><b>$imtxt{'51'}:</b></font></td><td><input type=checkbox name="imprev" $enable_imprev></td></tr>~;

	if($enable_mailpopup) {
	chomp($imconfig[3]);
	chomp($imconfig[5]);
	if($imconfig[3] eq "on") { $enable_userimpopup = 'checked'; }
	if($imconfig[5] eq "on") { $popup_userim = 'checked'; }
	$yymain .= qq~  <tr><td width="320"><font size=2><b>$imtxt{'05'}:</b></font></td><td><input type=checkbox name="userpopup" $enable_userimpopup></td></tr>
			<tr><td width="320"><font size=2><b>$imtxt{'53'}:</b></font></td><td><input type=checkbox name="popupims" $popup_userim></td></tr>~;
	} else { $yymain .= qq~ <input type=hidden name="userpopup" value="$imconfig[3]">
				<input type=hidden name="popupims" value="$imconfig[5]">~; }
chomp($imconfig[6]);
$imconfig[7] =~ s~<br>~\n~ig;
if($imconfig[6] eq "on") { $send_away_im = 'checked'; }
$yymain .= qq~  <tr><td width="320"><font size=2><b>$imtxt{'80'}</b></font></td><td><input type=checkbox name="sendaim" $send_away_im></td></tr>
     <tr>
      <td valign=top>
       <font size=2><b>$imtxt{'82'}</b></font><br><font size="1">$imtxt{'81'}</font>
      </td>
      <td>
       <font size=2><textarea name=awayim rows=4 cols=50 wrap=virtual>$imconfig[7]</textarea></font>
      </td>
     </tr>
    </table><BR>
    </td>
<!-- SIDEMENUE MOD BEGIN -->
~;
if ($xtc_sidemenue) {
$yymain .= qq~
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25"><font size=2><b>$sidemenuetxt{'21'} $txt{'605'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
    <table border=0 cellpadding="3" width="100%" cellspacing="0">
~;
if(-e "$memberdir/$INFO{'username'}.sidem") {$enable_sidem = 'checked';}
		fopen(FILE, "$vardir/membergroups.txt");
		@membergroups = <FILE>;
		fclose(FILE);
		chomp @membergroups;
		if(!-e "$sourcedir/MemberGroups.pl") {
			if($memsettings[6] >= $GodPostNum) { $memberinfo = "$membergroups[6]"; }
			elsif($memsettings[6] >= $SrPostNum) { $memberinfo = "$membergroups[5]"; }
			elsif($memsettings[6] >= $FullPostNum) { $memberinfo = "$membergroups[4]"; }
			elsif($memsettings[6] >= $JrPostNum) { $memberinfo = "$membergroups[3]"; }
			else { $memberinfo = "$membergroups[2]"; }
		}
		else {
			$memstatcount = "0";
			if( $memsettings[6] >= $MemPostNewbie) { $memberinfo = "$MemStatNewbie"; }
			while($MemStat[$memstatcount]) {
				if( $memsettings[6] >= $MemPostNum[$memstatcount] && $MemPostNum[$memstatcount] ne "x") {
					$memberinfo = "$MemStat[$memstatcount]";
				}
				$memstatcount++;
			}
		}
		$memberinfo =~ s/\n//gi;
		(@cursidemgroups) = split(/\,/, $xtc_grpallow);
		$edit_sidelink = 0;
		my($mssidecount);
		$mssidecount=0;
		foreach $tmpa (@cursidemgroups) {
			if( $tmpa eq $settings[7]) { $edit_sidelink = 1; last; }
	while($MemStat[$mssidecount]) {
	if($settings[6] >= $MemPostNum[$mssidecount] && $MemPostNum[$mssidecount] ne "x") {
	$memberinfo = "$MemStat[$mssidecount]"; }
	++$mssidecount;
	}
	if ( $memberinfo eq $tmpa ) { $edit_sidelink = 1; }
		}
		if( ! $xtc_grpallow || $settings[7] eq 'Administrator' ) { $edit_sidelink = 1; }
		$yymain .= qq~
		</tr><td><font size="2"><B>$sidemenuetxt{'21'}:</B></font><br><font size="1">$sidemenuetxt{'15'}</font></td>
		<td valign="top"><input type=checkbox name="show_sidemenue" $enable_sidem></td></tr>~;
	if($edit_sidelink) {
		$yymain .= qq~
		<tr><td><font size="2"><B>$sidemenuetxt{'01'}:</B></font><br><font size="1">$sidemenuetxt{'22'}</td>
		<td valign="top"><input type="button" value="$sidemenuetxt{'23'}" onClick="self.location.href='$scripturl?action=sideusermenuepanel;username=$INFO{'username'}'"></td></tr>~;
	}
	$yymain .= qq~
    </table><BR>
    </td>
~;
}
$yymain .= qq~
<!-- SIDEMENUE MOD END -->
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25"><font size=2><b>$txt{'605'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
    <table border=0 cellpadding="3" width="100%" cellspacing="0">
~;
	if ($allow_hide_email) {
		$yymain .= qq~
    <tr>
	<td width="320"><font size=2><b>$txt{'721'}</b></font></td>
     <td><input type="checkbox" name="hideemail" value="checked" $memsettings[19]></td>
    </tr>
~;
      }
      $yymain .= qq~
    <tr>
      <td width="320"><font size=2><b>Beitragsbenachrichtigung:</b></font><BR>
      <font size="1">Schaltet die eMail-Benachrichtigung standardmssig ein.</font</td>
      <td><input type="checkbox" name="notifyfeld" value="checked" $memsettings[20]></td>
    </tr>
      <tr>
	<td width="320"><font size=2><b>$txt{'486'}:</b></font><BR>
	<font size="1">$txt{'479'}</font></td>
	<td width="50">
	<select name="usertimeselect" size=1>
	<option value="1"$tsl1>$txt{'480'}
	<option value="2"$tsl2>$txt{'481'}
	<option value="3"$tsl3>$txt{'482'}
	<option value="4"$tsl4>$txt{'483'}
	<option value="5"$tsl5>$txt{'484'}
	<option value="6"$tsl6>$txt{'485'}
	</select>
	</td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'371'}:</b></font><BR>
	<font size="1">$txt{'519'}</font></td>
	<td><font size="1">
	<input name="usertimeoffset" size="5" maxlength="5" value="$memsettings[18]">
	<BR>$txt{'741'}: <i>$proftime</i></font></td>
      </tr><tr>
		<td colspan=2><br><hr width="100%" size="1" class="hr"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'85'}:</b></font><BR>
	<font size="1">$txt{'606'}</font></td>
	<td><font size=2><textarea name="signature" rows="4" cols="50" wrap="virtual">$signature</textarea><BR>
	<font size="1">$txt{'664'} <input value="$MaxSigLen" size="3" name="msgCL" disabled></FONT><BR><BR></font></td></tr>
	<script language="JavaScript">
	<!--
	var supportsKeys = false
	function tick() {
	  calcCharLeft(document.forms[0])
	  if (!supportsKeys) timerID = setTimeout("tick()",$MaxSigLen)
	}

	function calcCharLeft(sig) {
	  clipped = false
	  maxLength = $MaxSigLen
	  if (document.creator.signature.value.length > maxLength) {
		document.creator.signature.value = document.creator.signature.value.substring(0,maxLength)
		charleft = 0
		clipped = true
	  } else {
		charleft = maxLength - document.creator.signature.value.length
	  }
	  document.creator.msgCL.value = charleft
	  return clipped
	}

	tick();
	//-->
	</script>
~;
	fopen(FILE, "$vardir/membergroups.txt");
	@lines = <FILE>;
	fclose(FILE);
	if($settings[7] eq 'Administrator') {
		$position='';
		foreach $curl (@lines) {
			if($curl ne $lines[1] && $curl ne $lines[2] && $curl ne $lines[3] && $curl ne $lines[4] && $curl ne $lines[5] && $curl ne $lines[6]) {
				if($curl ne $lines[0] && $curl ne $lines[7]) { $position= qq~$position<option>$curl~; }
				elsif($curl eq $lines[0]) { $position= qq~$position<option value="Administrator">$curl~; }
				elsif($curl eq $lines[7]) { $position= qq~$position<option value="Global Moderator">$curl~; }
			}
		}
		if($memsettings[7] eq 'Administrator') { $tt = $lines[0]; }
		elsif($memsettings[7] eq 'Global Moderator') { $tt = $lines[7]; }
		else { $tt = $memsettings[7]; }
		$yymain .= qq~
      <tr>
	<td colspan=2><hr width="100%" size="1" class="hr"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$cuttxt{'1'}: </b></font></td>
	<td><font size=2><input type=text name=cutitle size=20 value="$titlesettings[0]"></font></td>
	</tr><tr>
	<td width="320"><font size=2><b>$txt{'86'}: </b></font></td>
	<td><font size=2><input type=text name=settings6 size=4 value="$memsettings[6]"></font></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'87'}: </b></font></td>
	<td><font size=2><select name="settings7">
	 <option value="$memsettings[7]">$tt
	 <option value="$memsettings[7]">---------------
	 <option value="">
	 $position
	</select></font></td>
      </tr><tr>
        <td width="320"><font size="2"><b>$txt{'233'}:</b></font><br>
        <font size="1">$txt{'421'}</font><br><br></td>
        <td><input type="text" name="dr" size="20" value="$dr"><br><br></td>
      </tr>~;
	if( $enable_board_notify == 3 || $enable_notification == 3) {
		fopen(FILE, "$memberdir/$INFO{'username'}.not");
			my $tmp_board_notify = <FILE> || 0;
			my $tmp_thread_notify = <FILE> || 0;
		fclose(FILE);
		chomp $tmp_board_notify;
		chomp $tmp_thread_notify;

		if( $enable_board_notify == 3) {$nbchecked = $tmp_board_notify == 1 ? " checked" : ""; $opt_board = qq~$bln_txt{'16'}: <input type="checkbox" name="notify_board" size="20" value="1"$nbchecked> &nbsp; &nbsp; ~;} else {$opt_board = "";}
		if( $enable_notification == 3) {$ntchecked = $tmp_thread_notify == 1 ? " checked" : ""; $opt_thread = qq~$bln_txt{'17'}: <input type="checkbox" name="notify_thread" size="20" value="1"$ntchecked>~;} else {$opt_thread = "";}

		$yymain .= qq~
      <tr>
        <td width="320"><font size="2"><b>$bln_txt{'15'}:</b></td>
        <td>$opt_board$opt_thread</td>
      </tr>~;
	}
	}
	if($settings[7] eq 'Administrator') { $confdel_text = "$txt{'775'} $txt{'777'} $INFO{'username'} $txt{'778'}"; }
	else { $confdel_text = "$txt{'775'} $txt{'776'} $txt{'778'}"; }
	$yymain .= qq~
    </table>
    </font></td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25" align="center"><font size=2><BR>
    <input type=submit name=moda value="$txt{'88'}">
~;
if($settings[7] eq 'Administrator') {$yymain .= qq~    <input type=submit name=moda value="$txt{'89'}" onClick="return confirm('$confdel_text')"><BR><BR>~;}
else {$yymain .= qq~<BR><BR>
<A HREF="$scripturl?board=;action=imsend;to=admin" TARGET="_self"><font size="1">$remdeltxt{'1'}<BR><BR></FONT></A>~;}
$yymain .= qq~
    </font></td>
  </tr>
</table>
</form>
~;
	$yytitle = $txt{'79'};
	&template;
	exit;
}

sub ModifyProfile2 {
	my( $ignorelist, $notify, $sound, $popup, $imprev, $imspop, $enableaim, $awayim);
	$ignorelist = "$FORM{'ignore'}";
	$notify = "$FORM{'notify'}";
	$sound = "$FORM{'usersound'}";
	$popup = "$FORM{'userpopup'}";
	$imprev = "$FORM{'imprev'}";
	$imspop = "$FORM{'popupims'}";
	$awayim = "$FORM{'awayim'}";
	$enableaim = "$FORM{'sendaim'}";

	$ignorelist =~ s~\A\n\s*~~;
	$ignorelist =~ s~\s*\n\Z~~;
	$ignorelist =~ s~\n\s*\n~\n~g;
	$ignorelist =~ s~[\n\r]~\|~g;
	$ignorelist =~ s~\|\|~\|~g;
	$notify =~ s~[\n\r]~~g;
	$sound =~ s~[\n\r]~~g;
	$popup =~ s~[\n\r]~~g;
	$imprev =~ s~[\n\r]~~g;
	$imspop =~ s~[\n\r]~~g;
	$enableaim =~ s~[\n\r]~~g;
	$awayim =~ s~[\n]~<BR>~g;
	my( %member, $key, $value, $newpassemail, @memberlist, $a, @check_settings, @reserve, $matchword, $matchcase, $matchuser, $matchname, $namecheck, $reserved, $reservecheck, @dirdata, $filename, @entries, $entry, $umail, @members, $tempname );
	$FORM{'signature'} =~ s~\n~\&\&~g;
	while( ($key,$value) = each(%FORM) ) {
		$value =~ s~\A\s+~~;
		$value =~ s~\s+\Z~~;
		$value =~ s~[\n\r]~~g;
		$member{$key} = $value;
	}

	# make sure this person has access to this profile
	if($username ne $member{'username'} && $settings[7] ne 'Administrator') { &fatal_error($txt{'80'}); }
	if( $settings[7] ne 'Administrator' ) {
		$member{'username'} = $username;
		$member{'settings6'} = $settings[6];
		$member{'settings7'} = $settings[7];
	}
	if($member{'settings6'} !~ /\A[0-9]+\Z/) { &fatal_error("$txt{'749'}"); }
	if($member{'gbtotal'} !~ /\A[0-9]+\Z/) { &fatal_error("$gsttxt{'12'} $gsttxt{'15'}"); }
	if($member{'gbtotal'} > $MaxGuestPosts) { $member{'gbtotal'} = $MaxGuestPosts }
	if($member{'gbchar'} !~ /\A[0-9]+\Z/) { &fatal_error("$gsttxt{'14'} $gsttxt{'15'}"); }
	if($member{'gbchar'} > $MaxGuestChars) { &fatal_error("$gsttxt{'17'} $MaxGuestChars"); }
	if ($member{'username'} =~ /\//){ &fatal_error($txt{'224'}); }
	if ($member{'username'} =~ /\\/){ &fatal_error($txt{'225'}); }
	$INFO{'username'} = $member{'username'};
	if(length($member{'usertext'}) > 51) { &fatal_error("$txt{'757'}"); }
	if( $member{'userpicpersonalcheck'} && ( $member{'userpicpersonal'} =~ m/\.gif\Z/i || $member{'userpicpersonal'} =~ m/\.jpg\Z/i || $member{'userpicpersonal'} =~ m/\.jpeg\Z/i || $member{'userpicpersonal'} =~ m/\.png\Z/i ) ) {
		$member{'userpic'} = $member{'userpicpersonal'};
	}
	if($member{'userpic'} eq "") { $member{'userpic'} = "blank.gif"; }
	&fatal_error("$txt{'592'}") if($member{'userpic'} !~ m^\A[0-9a-zA-Z_\.\#\%\-\:\+\?\$\&\~\.\,\@/]+\Z^);
	if($FORM{'aktwidth'} !~ /\A[0-9]+\Z/) { &fatal_error("$siztxt{'02'}"); }
	if($FORM{'aktheight'} !~ /\A[0-9]+\Z/) { &fatal_error("$siztxt{'03'}"); }
	if($FORM{'aktwidth'} < 1) { &fatal_error("$siztxt{'02'}"); }
	if($FORM{'aktheight'} < 1) { &fatal_error("$siztxt{'03'}"); }
	if(!$allowpics) { $member{'userpic'} = "blank.gif"; }
	if( $emailnewpass && lc $member{'email'} ne lc $settings[2] && $settings[7] ne 'Administrator') {
		srand();
		$member{'passwrd1'} = int( rand(100) );
		$member{'passwrd1'} =~ tr/0123456789/ymifxupbck/;
		$_ = int( rand(77) );
		$_ =~ tr/0123456789/q8dv7w4jm3/;
		$member{'passwrd1'} .= $_;
		$_ = int( rand(89) );
		$_ =~ tr/0123456789/y6uivpkcxw/;
		$member{'passwrd1'} .= $_;
		$_ = int( rand(188) );
		$_ =~ tr/0123456789/poiuytrewq/;
		$member{'passwrd1'} .= $_;
		$_ = int( rand(65) );
		$_ =~ tr/0123456789/lkjhgfdaut/;
		$member{'passwrd1'} .= $_;
		$newpassemail = 1;
	} else {
		&fatal_error("($member{'username'}) $txt{'213'}") if($member{'passwrd1'} ne $member{'passwrd2'});
		&fatal_error("($member{'username'}) $txt{'91'}") if($member{'passwrd1'} eq '');
		&fatal_error("$txt{'240'} $txt{'36'} $txt{'241'}") if($member{'passwrd1'} !~ /\A[\s0-9A-Za-z!@#$%\^&*\(\)_\+|`~\-=\\:;'",\.\/?\[\]\{\}]+\Z/);
	}
	&fatal_error("$txt{'75'}") if($member{'name'} eq '');
	&fatal_error("$txt{'240'} $txt{'68'} $txt{'241'}") if($member{'name'} !~ /^[\s0-9A-Za-z\[\]#%+,-|\.:=?@^_]+$/);
	&fatal_error("$txt{'75'}") if($member{'name'} eq '|');
	&fatal_error("$txt{'568'}") if(length($member{'name'}) > 30);
	&fatal_error("$txt{'76'}") if($member{'email'} eq '');
	&fatal_error("$txt{'240'} $txt{'69'} $txt{'241'}") if($member{'email'} !~ /[\w\-\.\+]+\@[\w\-\.\+]+\.(\w{2,4}$)/);
	&fatal_error("$txt{'500'}") if(($member{'email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($member{'email'} !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/));
	if( $member{'bday1'} ne "" || $member{'bday2'} ne "" || $member{'bday3'} ne "" ) {
		&fatal_error("$txt{'567'}") if( $member{'bday1'} !~ /^[0-9]+$/ || $member{'bday2'} !~ /^[0-9]+$/ || $member{'bday3'} !~ /^[0-9]+$/ || length($member{'bday3'}) < 4 );
		&fatal_error("$txt{'567'}") if( $member{'bday1'} < 1 || $member{'bday1'} > 12 || $member{'bday2'} < 1 || $member{'bday2'} > 31 || $member{'bday3'} < 1901 || $member{'bday3'} > $year-5 );
	}
	&fatal_error("$txt{'680'}") if ($member{'username'} eq "admin" && $member{'settings7'} ne "Administrator");

	if($member{'moda'} eq $txt{'88'}) {
		if (length($member{'signature'}) > $MaxSigLen) { $member{'signature'} = substr($member{'signature'},0,$MaxSigLen); }
	        $member{'icq'} =~ s/[^0-9]//g;
		$member{'bday1'} =~ s/[^0-9]//g;
	        $member{'bday2'} =~ s/[^0-9]//g;
		$member{'bday3'} =~ s/[^0-9]//g;
		if($member{'bday1'}) { $member{'bday'} = "$member{'bday1'}/$member{'bday2'}/$member{'bday3'}"; }
		else { $member{'bday'} = ''; }
		$member{'signature'} =~ s/</&lt;/g;
	        $member{'signature'} =~ s/</&gt;/g;
	        $member{'aim'} =~ s/ /\+/g;
	        $member{'yim'} =~ s/ /\+/g;
		if($settings[7] ne "Administrator") { $member{'dr'} = $settings[14]; }
		# store the name temorarily so we can restore any _'s later
		$tempname = $member{'name'};
		$member{'name'} =~ s/\_/ /g;

		if($member{'mapcountry'} eq "Noflag") { $member{'mapcountry'} = "" }
		&ToHTML($member{'cityloc'});
		if($view_state) { &ToHTML($member{'mapstate'}); }
		&ToHTML($member{'mapcountry'});
		&ToHTML($member{'contselect'});
		&ToHTML($member{'xcoord'});
		&ToHTML($member{'ycoord'});
		&ToHTML($member{'aim'});
		&ToHTML($member{'yim'});
		&ToHTML($member{'gender'});
		&ToHTML($member{'usertext'});
		&ToHTML($member{'websiteurl'});
		&ToHTML($member{'websitetitle'});
		&ToHTML($member{'email'});
		&ToHTML($FORM{'hideemail'});
		&ToHTML($member{'name'});
		&ToHTML($member{'msn'});

		&FromHTML($member{'usertext'});
		$member{'usertext'} =~ s~(\S{15})(?=\S)~$1 ~g;
		&ToHTML($member{'usertext'});

		if ( length $member{'signature'} > 1000 ) { $member{'signature'} = substr( $member{'signature'}, 0, 1000 ); }
		$member{'usertimeoffset'} =~ tr/,/./;
		$member{'usertimeoffset'} =~ s/[^\d*|\.|\-|w*]//g;
		if (( $member{'usertimeoffset'} < -23.5) || ( $member{'usertimeoffset'} > 23.5)) { &fatal_error($txt{'487'}); }

		$testname = lc $member{'name'};
		$testemail = lc $member{'email'};

		if($member{'name'} ne $member{'oldname'} || $member{'email'} ne $member{'oldemail'}){
			$doublecheck = &profilecheck($member{'username'},$testname,$testemail,"check");
			if($doublecheck eq "email_exists"){&fatal_error("$txt{'730'} ($member{'email'}) $txt{'731'}");}
			if($doublecheck eq "realname_exists"){&fatal_error("($member{'name'}) $txt{'473'}");}
		}

		fopen(FILE, "$vardir/reserve.txt") || &fatal_error("$txt{'23'} reserve.txt");
		@reserve = <FILE>;
		fclose(FILE);
		fopen(FILE, "$vardir/reservecfg.txt") || &fatal_error("$txt{'23'} reservecfg.txt");
		@reservecfg = <FILE>;
		fclose(FILE);
		for($a = 0; $a < @reservecfg; $a++) { chomp $reservecfg[$a]; }
		$matchword = $reservecfg[0] eq 'checked';
		$matchcase = $reservecfg[1] eq 'checked';
		$matchuser = $reservecfg[2] eq 'checked';
		$matchname = $reservecfg[3] eq 'checked';
		$namecheck = $matchcase eq 'checked' ? $member{'name'} : lc $member{'name'};

		foreach $reserved (@reserve) {
			chomp $reserved;
			$reservecheck = $matchcase ? $reserved : lc $reserved;
			if ($matchname) {
				if ($matchword) {
					if ($namecheck eq $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
				else {
					if ($namecheck =~ $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
			}
		}
$member{'aktwidth'} = $FORM{'aktwidth'};
$member{'aktheight'} = $FORM{'aktheight'};
fopen( FILE, ">$memberdir/$member{'username'}.siz", 1);
print FILE "$member{'aktwidth'}\n";
print FILE "$member{'aktheight'}\n";
fclose(FILE);

$member{'msn'} = $FORM{'msn'};
fopen( FILE, ">$memberdir/$member{'username'}.om", 1);
print FILE "$member{'msn'}";
fclose(FILE);

##### BEGIN SIDEMENUE MOD ####
if ($FORM{'show_sidemenue'}) {
if (!-e "$memberdir/$member{'username'}.sidem") {
fopen( FILE, ">$memberdir/$member{'username'}.sidem", 1);
fclose(FILE);
}
} else { unlink("$memberdir/$member{'username'}.sidem");
}
#### END SIDEMENUE MOD ####
		# let's restore the name now
		&ToHTML($tempname);
		$member{'name'} = $tempname;

		fopen(MEMBERFILEREAD,"$memberdir/$member{'username'}.dat");
		my @memset = <MEMBERFILEREAD>;
		fclose(MEMBERFILEREAD);
		chomp @memset;
		$oldemail = $memset[2];

		fopen(FILE, "$memberdir/$member{'username'}.not");
			my $old_notifyboard = <FILE> || 0;
			my $old_notifythread = <FILE> || 0;
		fclose(FILE);
		chomp $old_notifyboard;
		chomp $old_notifythread;

		if( $settings[7] eq 'Administrator' && $enable_board_notify == 3) {$member{'notify_board'} = $FORM{'notify_board'} ? 1 : 0;} else {$member{'notify_board'} = $old_notifyboard ? 1 : 0;}
		if( $settings[7] eq 'Administrator' && $enable_notification == 3) {$member{'notify_thread'} = $FORM{'notify_thread'} ? 1 : 0;} else {$member{'notify_thread'} = $old_notifythread ? 1 : 0;}

		# if changed email address, update notifications
		if ($member{'email'} ne $oldemail || $member{'notify_board'} ne $old_notifyboard || $member{'notify_thread'} ne $old_notifythread) {
			fopen(FILE, ">$memberdir/$member{'username'}.not");
				print FILE "$member{'notify_board'}\n";
				print FILE "$member{'notify_thread'}\n";
			fclose(FILE);
			require "$sourcedir/Notify.pl";
			if ($member{'email'} ne $oldemail || $member{'notify_board'} ne $old_notifyboard) {&replace_notifications($oldemail, $member{'email'}, $member{'notify_board'}, 0);}
			if ($member{'email'} ne $oldemail || $member{'notify_thread'} ne $old_notifythread) {&replace_notifications($oldemail, $member{'email'}, $member{'notify_thread'}, 1);}
		}

if($member{'kode'} eq "x0" || $member{'kode'} eq "x1") {
	$memblocal = $member{'cityloc'};
	if($view_state) { $membstate = $member{'mapstate'} }
	else { $membstate = "" }
	$membcountry = $member{'mapcountry'};
	$membcontinent = $member{'contselect'};
	$membx = $member{'xcoord'};
	$memby = $member{'ycoord'};
	$loccode = $member{'kode'};
	$member{'location'} .= qq($loccode|$memblocal|$membcountry|$membcontinent|$membx|$memby|$membstate);
}
else {
	$member{'location'} = "x0";
}

###### Newcalendar mod start
		fopen(MEMBERFILE,"$memberdir/$member{'username'}.dat");
		@member = <MEMBERFILE>;
		fclose(MEMBERFILE);
		chomp(@member);
		$old_bday = $member[16];
###### Newcalendar mod end

		fopen(FILE, "+>$memberdir/$member{'username'}.imconfig");
		print FILE "$ignorelist\n$notify\n$sound\n$popup\n$imprev\n$imspop\n$enableaim\n$awayim";
		fclose(FILE);
		require "$sourcedir/ExtendedProfiles.pl";
		my $error = &ext_validate_submition($member{'username'},$username);
		if ($error ne "") { &fatal_error($error); } else { &ext_saveprofile($member{'username'}); }

		fopen( FILE, ">$memberdir/$member{'username'}.dat", 1);
		print FILE "$member{'passwrd1'}\n";
		print FILE "$member{'name'}\n";
		print FILE "$member{'email'}\n";
		print FILE "$member{'websitetitle'}\n";
		print FILE "$member{'websiteurl'}\n";
		print FILE "$member{'signature'}\n";
		print FILE "$member{'settings6'}\n";
		print FILE "$member{'settings7'}\n";
		print FILE "$member{'icq'}\n";
		print FILE "$member{'aim'}\n";
		print FILE "$member{'yim'}\n";
		print FILE "$member{'gender'}\n";
		print FILE "$member{'usertext'}\n";
		print FILE "$member{'userpic'}\n";
		print FILE "$member{'dr'}\n";
		print FILE "$member{'location'}\n";
		print FILE "$member{'bday'}\n";
		print FILE "$member{'usertimeselect'}\n";
		print FILE "$member{'usertimeoffset'}\n";
           if ($FORM{'hideemail'} ne "checked") { $FORM{'hideemail'} = ""; }
            print FILE "$FORM{'hideemail'}\n";
            print FILE "$FORM{'notifyfeld'}\n";
		fclose(FILE);

		&profilecheck($member{'username'},$member{'name'},$testemail,"update");

###### Newcalendar mod start
if ( $old_bday ne $member{'bday'}) {require "$sourcedir/Admin.pl"; &RebuildMemBirth;}
###### Newcalendar mod end


	fopen(FILE, ">$memberdir/$FORM{'username'}.gbs", 1);
		if ($FORM{'gbview'} ne "checked") { $FORM{'gbview'} = ""; }
		if($gballowguest) { if ($FORM{'gbguests'} ne "checked") { $FORM{'gbguests'} = ""; } }
		else { $FORM{'gbguests'} = ""; }
		print FILE "$FORM{'gbview'}\n";
		print FILE "$member{'gbtotal'}\n";
		print FILE "$member{'gbchar'}\n";
		print FILE "$FORM{'gbguests'}\n";
	fclose(FILE);

		# Forum Staff Info - Update Membergroup list
		fopen(FILE,"+<$vardir/mem_groups.txt");
			seek FILE, 0, 0;
			@mem_groups = <FILE>;
			truncate FILE, 0;
			seek FILE, 0, 0;
			for ($a = 0; $a < @mem_groups; $a++) {
				if ( $mem_groups[$a] =~ m~\A$member{'username'}\|~o ) { $mem_groups[$a] = ""; last; }
			}
			if ( $member{'settings7'} ne "" ) { print FILE qq~$member{'username'}|$member{'settings7'}|$member{'name'}\n~; }
			print FILE @mem_groups;
		fclose(FILE);


		if ($settings[7] eq 'Administrator') {
		fopen( FILE, ">$memberdir/$member{'username'}.title");
		print FILE "$member{'cutitle'}";
		fclose(FILE);
                }

$mdfile[0] = $FORM{'mood'};
fopen(FILE, ">$memberdir/$member{'username'}.mod");
print FILE "$mdfile[0]";
fclose(FILE);
$mrstfile[0] = $FORM{'relation'};
fopen(FILE, ">$memberdir/$member{'username'}.rst");
print FILE "$mrstfile[0]";
fclose(FILE);
	if($newpassemail) {

	# Write log
	fopen(LOG, "+<$vardir/log.txt",1);
		@online_log = <LOG>;
		seek LOG, 0, 0;
		truncate LOG, 0;
		for(my $i = 0; $i <= $#online_log; $i++) {
			my ($tmp_name, $tmp_online, $tmp_ip, $tmp_time, $dummy ) = split( /\|/, $online_log[$i], 5 );
			if (($time - $tmp_time) > ($OnlineLogTime * 60)) {last;}
			if ($tmp_name eq $username) {$online_log[$i] = "$tmp_name\|\|$tmp_ip\|$tmp_time\|$dummy";}
		}
		print LOG @online_log;
	fclose(LOG);

	$yySetCookies1 = cookie(-name    =>   "$cookieusername",
				-value   =>   "",
				-path    =>   "/",
				-expires =>   "Thursday, 01-Jan-1970 00:00:00 GMT");
	$yySetCookies2 = cookie(-name    =>   "$cookiepassword",
				-value   =>   "",
				-path    =>   "/",
				-expires =>   "Thursday, 01-Jan-1970 00:00:00 GMT");
	$username = 'Guest';
	$password = '';
	@settings = ();
	$realname = '';
	$realemail = '';
	$ENV{'HTTP_COOKIE'} = '';
	&FormatUserName($member{'username'});
	&sendmail($member{'email'},qq~$txt{'700'} $mbname~, "$txt{'733'} $member{'passwrd1'} $txt{'734'} $member{'username'}.\n\n$txt{'701'} $scripturl?action=profile;username=$useraccount{$member{'username'}}\n\n$txt{'130'}");
	$yymain .= qq~<br><table border="0" width="100%" cellspacing="1" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">~;

	require "$sourcedir/LogInOut.pl";
	$sharedLogin_title="$txt{'34'}";
	$sharedLogin_text="$txt{'638'}";
	&sharedLogin;

	$yymain .= qq~</table>~;
	$yytitle="$txt{'245'}";
	&template;
	exit;
	}
	else {
		if ($member{'username'} eq $username) {
			$password = crypt("$member{'passwrd1'}",$pwseed);
			$yySetCookies1 = cookie(-name    =>   "$cookieusername",
						-value   =>   "$username",
						-path    =>   "/",
						-expires =>   "Sunday, 17-Jan-2038 00:00:00 GMT");
			$yySetCookies2 = cookie(-name    =>   "$cookiepassword",
						-value   =>   "$password",
						-path    =>   "/",
						-expires =>   "Sunday, 17-Jan-2038 00:00:00 GMT");
			&LoadUserSettings;
			&WriteLog;
		}
		&ViewProfile;
	}
	} else {
	if($member{'username'} ne "admin") {
		require "$sourcedir/Notify.pl";
		remove_notifications($member{'email'});

	# For security, remove username from mod position
	fopen(FILE, "$vardir/cat.txt"); @categories = <FILE>; fclose(FILE);

	foreach $curcat (@categories) {
		$curcat =~ s/[\n\r]//g;
		fopen(CAT, "$boardsdir/$curcat.cat"); @catinfo = <CAT>; fclose(CAT);

		foreach $curboard (@catinfo) {
				$curboard =~ s/[\n\r]//g; chomp $curboard;

				fopen(BOARD, "$boardsdir/$curboard.dat"); @boardinfo = <BOARD>; fclose(BOARD);

				$boardinfo[2] =~ s/[\n\r]//g; $boardinfo[2] =~ /^\|(.*?)\|$/;
				$mods = $1 or $mods = $boardinfo[2];
                                $mods =~ s/(\s*)//g;              # remove all whitespaces
				$mods =~ s/(^(\|)+)?((\|)+$)?//;  # remove unnecessary front and back separator
				$mods =~ s/(\|)+/\|/g;            # replace multiple separators with one separator

				my @mod_ary = split(/\|/, $mods);
				my @new_mod_ary;
				my $mods_changed = 0;
				foreach my $mod( @mod_ary) {
					if( $settings[7] eq 'Administrator') {
						if( $member{'username'} ne $mod) {
							push( @new_mod_ary, $mod);
						} else {
							$mods_changed = 1;
						}
					} elsif( $member{'username'} eq $username) {
						if( $username ne $mod) {
							push( @new_mod_ary, $mod);
						} else {
							$mods_changed = 1;
						}
					}
				}
				$mods = join( "|", @new_mod_ary);

				if ($mods_changed == 1)
				{
					$boardinfo[2] = $mods;
					fopen(BOARD, ">$boardsdir/$curboard.dat", 1);
					print BOARD @boardinfo;
					fclose(BOARD);
				}
		}
	}
		if($settings[7] eq 'Administrator') {
			unlink("$memberdir/$member{'username'}.title");
			unlink("$memberdir/$member{'username'}.home");
			unlink("$memberdir/$member{'username'}.dat");
			unlink("$memberdir/$member{'username'}.msg");
			unlink("$memberdir/$member{'username'}.log");
	                unlink("$memberdir/$member{'username'}.outbox");
	                unlink("$memberdir/$member{'username'}.imconfig");
			unlink("$memberdir/$member{'username'}.sidem");
			unlink("$memberdir/$member{'username'}.ext");
	                unlink("$memberdir/$member{'username'}.om");
	                unlink("$memberdir/$member{'username'}.rst");
	                unlink("$memberdir/$member{'username'}.mod");
			&profilecheck($member{'username'},"-","-","delete");
	                unlink("$memberdir/$member{'username'}.ll");
	                unlink("$memberdir/$member{'username'}.quiz");
	                unlink("$memberdir/$member{'username'}.quizlog");
			unlink("$memberdir/$member{'username'}.not");
	                unlink("$memberdir/$member{'username'}.buddy");
	                unlink("$memberdir/$member{'username'}.storage");
	                if (-e "$memberdir/$member{'username'}.siz") { unlink("$memberdir/$member{'username'}.siz"); }
	                unlink("$memberdir/$member{'username'}.gst");
	                unlink("$memberdir/$member{'username'}.gbs");
		}
		elsif( $member{'username'} eq $username ) {
			unlink("$memberdir/$username.title");
			unlink("$memberdir/$username.home");
			unlink("$memberdir/$username.dat");
			unlink("$memberdir/$username.msg");
			unlink("$memberdir/$username.log");
	                unlink("$memberdir/$username.outbox");
	                unlink("$memberdir/$username.imconfig");
	                unlink("$memberdir/$username.sidem");
			unlink("$memberdir/$username.ext");
	                unlink("$memberdir/$username.om");
	                unlink("$memberdir/$username.rst");
	                unlink("$memberdir/$username.mod");
			&profilecheck($username,"-","-","delete");
	                unlink("$memberdir/$username.ll");
	                unlink("$memberdir/$username.quiz");
	                unlink("$memberdir/$username.quizlog");
	                unlink("$memberdir/$username.not");
	                unlink("$memberdir/$username.buddy");
	                unlink("$memberdir/$username.storage");
	                if (-e "$memberdir/$username.siz") { unlink("$memberdir/$username.siz"); }
	                unlink("$memberdir/$username.gst");
	                unlink("$memberdir/$username.gbs");
		}

		# Forum Staff Info - Delete User from Membergroup list
		fopen(FILE,"+<$vardir/mem_groups.txt");
			seek FILE, 0, 0;
			@mem_groups = <FILE>;
			truncate FILE, 0;
			seek FILE, 0, 0;
			for ($a = 0; $a < @mem_groups; $a++) {
				if ( $mem_groups[$a] =~ m~\A$member{'username'}\|~o ) { $mem_groups[$a] = ""; last; }
			}
			print FILE @mem_groups;
		fclose(FILE);

		opendir (DIRECTORY,"$datadir");
		@dirdata = readdir(DIRECTORY);
		closedir (DIRECTORY);

		if($settings[7] eq 'Administrator') {
			$umail=$member{'email'};
		} else {
			$umail=$settings[2];
		}
		foreach $filename (@dirdata) {
			unless( $filename =~ m~mail\A~ ) { next; }
			fopen(FILE, "$datadir/$filename");
			@entries = <FILE>;
			fclose(FILE);

			fopen(FILE, ">$datadir/$filename");
			foreach $entry (@entries) {
				$entry =~ s/[\n\r]//g;
				if ($entry ne $umail) {
					print FILE "$entry\n";
				}
			}
			fclose(FILE);

		}

		fopen(FILE, "$memberdir/memberlist.txt");
		@members = <FILE>;
		fclose(FILE);
		fopen(FILE, ">$memberdir/memberlist.txt", 1);
		my $memberfound = 0;
		my $lastvalidmember = '';
		foreach $curmem (@members) {
			chomp $curmem;
			if($curmem ne $member{'username'}) { print FILE "$curmem\n"; $lastvalidmember = $curmem; }
			else { ++$memberfound; }
		}
		fclose(FILE);
		my $membershiptotal = @members - $memberfound;
		fopen(FILE, "+>$memberdir/members.ttl");
		print FILE qq~$membershiptotal|$lastvalidmember~;
		fclose(FILE);

###### Newcalendar mod start
require "$sourcedir/Admin.pl"; &RebuildMemBirth;
###### Newcalendar mod end

		if($settings[7] ne 'Administrator') {
			require "$sourcedir/LogInOut.pl"; &Logout;
		}
		$yySetLocation = qq~$scripturl~;
		&redirectexit;
	}
	else { &fatal_error("$txt{'751'}"); }
	}
	exit;
}

sub ViewProfile {
	if($username eq "Guest") { &fatal_error("$txt{'223'}"); }
	if ($INFO{'username'} =~ /\//){ &fatal_error("$txt{'224'}" ); }
	if ($INFO{'username'} =~ /\\/){ &fatal_error("$txt{'225'}" ); }
	if(!-e ("$memberdir/$INFO{'username'}.dat")){ &fatal_error("$txt{'453'} -- $INFO{'username'}"); }

	my($memberinfo, $modify, $email, $gender, $pic, $modifyloc, $prolocal, $prostate, $procountry, $initstate, $namestate);

	# get the member's info
if(!-e ("$memberdir/$INFO{'username'}.gbs")) {
	fopen(FILE, ">$memberdir/$INFO{'username'}.gbs", 1);
		print FILE "checked\n";
		print FILE "$MaxGuestPosts\n";
		print FILE "$MaxGuestChars\n";
		print FILE "checked\n";
	fclose(FILE);
}

	fopen(FILE, "$memberdir/$INFO{'username'}.gbs");
	@gbsettings=<FILE>;
	fclose(FILE);
	chomp @gbsettings;
	fopen(FILE, "$memberdir/$INFO{'username'}.dat");
	@memsettings=<FILE>;
	fclose(FILE);
	chomp @memsettings;
      ##rst in profile##
	     fopen(FILE, "$memberdir/$INFO{'username'}.rst");
			@relationship = <FILE>;
			fclose(FILE);
chomp @relationship;
$rsttest = $relationship[0];
if($rsttest eq '') {$rsttest = "";}
      ##rst in profile end##
                     ##mood in profile##
fopen(FILE, "$memberdir/$INFO{'username'}.mod");
			@moody = <FILE>;
			fclose(FILE);
chomp @moody;
$modtest = $moody[0];
if($modtest eq '') {$modtest = "blank";}
      ##mood in profile end##
	$icq = $memsettings[8];
      ##rst in profile##
     if($relationship[0] ne "") {
           $rsttxt = qq~$relationship[0]~;
     }
     else {
       $rsttxt = "";
     }
      ##rst in profile end##
                         ##mood in profile##
     if($moody[0] ne "") {
           $moodimg = qq~<img src="$imagesdir/moods/$modtest.gif" border="0" alt="$moody[0]">~;
     }
     else {
       $moodimg = "";
     }
      ##mood in profile end##
###Better Signature in Profile Mod START###
		$memsettings[5] =~ s~\&\&~<br>~g;
		$showursig = $memsettings[5];
###Better Signature in Profile Mod STOP###
	if($memsettings[4] !~ m~\Ahttp://~) { $memsettings[4] = "http://$memsettings[4]"; }
	$memsettingsd[9] = $memsettings[9]; $memsettingsd[9] =~ tr/+/ /;
	$memsettingsd[10] = $memsettings[10]; $memsettingsd[10] =~ tr/+/ /;
	$dr = "";
	if ($memsettings[14] eq "") { $dr = "$txt{'470'}"; }
	else { $dr = "$memsettings[14]"; $dr = &timeformat($dr); }
	&CalcAge("calc"); # How old is he/she?
	&CalcAge("isbday"); # is it the bday?
	if($isbday) { $isbday = "<img src=\"$imagesdir/bdaycake.gif\" width=40>"; }

	fopen(FILE, "$vardir/membergroups.txt");
	@membergroups = <FILE>;
	fclose(FILE);
	if($memsettings[6] > $GodPostNum) { $memberinfo = "$membergroups[6]"; }
	elsif($memsettings[6] > $SrPostNum) { $memberinfo = "$membergroups[5]"; }
	elsif($memsettings[6] > $FullPostNum) { $memberinfo = "$membergroups[4]"; }
	elsif($memsettings[6] > $JrPostNum) { $memberinfo = "$membergroups[3]"; }
	else { $memberinfo = "$membergroups[2]"; }
	if($memsettings[7] ne "") { $memberinfo = "$memsettings[7]"; }
	if($memsettings[7] eq "Administrator") { $memberinfo = "$membergroups[0]"; }

	&FormatUserName($INFO{'username'});
	if ($username eq $INFO{'username'} || $settings[7] eq "Administrator") {
		$theuser = $INFO{'username'};
		$modify = qq~&#171; <a href="$cgi;action=profile;username=$useraccount{$INFO{'username'}}"><font size=2 class="text1" color="$color{'titletext'}">$txt{'17'}</font></a> &#187;~;
		$modifyloc = qq~&#171; <a href=javascript:MapEditwin('$cgi&action=mmedit&username=$theuser')><font size=2 class="text1" color="$color{'titletext'}">$maptxt{'12'}</font></a> &#187;~;
		$modifyloc1 = qq~&#171; <a href=javascript:MapEditwin('$cgi&action=mmedit&username=$theuser')><font size=2>$maptxt{'12'}</font></a> &#187;~;
	}
	$cryptmail = &scramble($memsettings[2]);
	$membermail = qq~$scripturl?action=mailto;user=$username;mail_id=$cryptmail~;
	if ($username ne $INFO{'username'} && ($settings[7] eq "Global Moderator" && $allowgmod_editprof)) {
		$modify = qq~&#171; <a href="$cgi;action=gmodeditprofile;username=$useraccount{$INFO{'username'}}"><font size=2 class="text1" color="$color{'titletext'}">$txt{'17'}</font></a> &#187;~;
	}
	if ($memsettings[19] ne "checked" || $settings[7] eq "Administrator" || ($settings[7] eq 'Global Moderator' && $showgmod_email ) || !$allow_hide_email) {
		$email = qq~<a href="$membermail" target="_blank">$txt{'hidemail'} $memsettings[1] $txt{'hidemail2'}</a>~;
	}
	else { $email = qq~<i>$txt{'722'}</i>~; }
	$gender = "";
	if ($memsettings[11] eq "Male") { $gender = qq~$txt{'238'}~; }
	if ($memsettings[11] eq "Female") { $gender = qq~$txt{'239'}~; }
	if($allowpics) {
	if (-e "$memberdir/$INFO{'username'}.siz") {
		fopen(IMGSIZFILEREAD,"$memberdir/$INFO{'username'}.siz");
		@imgsize = <IMGSIZFILEREAD>;
		fclose(IMGSIZFILEREAD);
		chomp @imgsize;
		$akt_width = $imgsize[0];
		$akt_height = $imgsize[1];
	}
	else {
		$akt_width = 65;
		$akt_height = 65;
	}
	if ($memsettings[13] =~ /^\http:\/\// ) {
		&set_picsize($akt_width, $akt_height, $userpic_width, $userpic_height);
		$tmp_width = "width=$akt_width";
		$tmp_height = "height=$akt_height";
		$pic = qq~<a href="$memsettings[13]" target="_blank" onClick="window.open('$memsettings[13]', 'ppic$INFO{username}', 'resizable,width=200,height=200'); return false;">~;
                $pic .= qq~<img src="$memsettings[13]" $tmp_width $tmp_height border="0" alt=""></a>~;
	}
	else {
		$pic = qq~<a href="$facesurl/$memsettings[13]" target="_blank" onClick="window.open('$facesurl/$memsettings[13]', 'ppic$INFO{username}', 'resizable,width=200,height=200'); return false;">~;
                $pic .= qq~<img src="$facesurl/$memsettings[13]" border="0" alt=""></a>~;
	}
	}

	#homepage mod - do we want a link
	if (-e("$memberdir/$INFO{'username'}.home"))
	{
		unless ($username eq 'Guest' && !$guests_view_hp)
		{
			fopen(FILE, "$memberdir/$INFO{'username'}.home"); $hp = <FILE>; fclose(FILE);
			chomp $hp;
			($junk, $junk, $hp_banned) = split(/\|/, $hp);

			if ($hp_banned) { $homepage_link = $txt{'470'}; }
			else { $homepage_link = qq~<a href="$cgi;action=hpview;member=$INFO{'username'}">$hp_txt{'20'}</a>~; }
		}
	}
	else { $homepage_link = $txt{'470'}; }
	$online = "$txt{'113'} ?";
	foreach $curentry (@online_log) {
		($tmp_name, $tmp_online, $tmp_ip, $tmp_time, $dummy) = split(/\|/, $curentry, 5);
		if (($time - $tmp_time) > ($OnlineLogTime * 60)) {last;}
		if($tmp_name && $tmp_online) {
			&LoadUser($tmp_name);
			if(lc $tmp_name eq lc $INFO{'username'}) {
				$online =~ s~\?~<i>$txt{'686'}</i>.~;
				last;
			}
		}
	}
	fopen(FILE, "$memberdir/$INFO{'username'}.ll");
		my ($userlastlogin, $userlastpost, $userlastim) = <FILE>;
	fclose(FILE);
	$userlastlogin =~ s/\n//g; $userlastlogin = &timeformat($userlastlogin);
	$userlastpost =~ s/\n//g; $userlastpost = &timeformat($userlastpost);
	$userlastim =~ s/\n//g; $userlastim = &timeformat($userlastim);
	if ($userlastlogin eq "") { $userlastlogin = "$txt{'470'}"; }
	if ($userlastpost eq "") { $userlastpost = "$txt{'470'}"; }
	if ($userlastim eq "") { $userlastim = "$txt{'470'}"; }
	$online =~ s~\?~<i>$txt{'687'}</i>.~;
	if($memsettings[6] > 100000) { $memsettings[6] = "$txt{'683'}"; }
################ START ADVANCED POST STATS MOD ################

	if ($yyCatsLoaded ne 1) {
		fopen(FILE, "$vardir/cat.txt");
		@categories = <FILE>;
		fclose(FILE);
		$yyCatsLoaded = 1;
	}
	$totalm = 0;
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
			$catname{$curcat} = <FILE>;
			chomp $catname{$curcat};
			$cataccess{$curcat} = <FILE>;
			chomp $cataccess{$curcat};
			@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $cataccess{$curcat} );
		$openmemgr{$curcat} = 0;
		foreach $tmpa (@membergroups) { if($tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; } }
		if(!$cataccess{$curcat} || $settings[7] eq 'Administrator') { $openmemgr{$curcat} = 1; }
		unless($openmemgr{$curcat}) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($curboard);
			$messagecount{$curboard} = $messagecount || 0;
			$totalm += $messagecount;
		}
	}

	if ($forumstartdate !~ /^\d\d\/\d\d\/\d\d $txt{'107'} \d\d\:\d\d\:\d\d$/ig) {
		$forumstartdate = "10/11/00 at 00:00:00";
	}

	if ($totalm > 0) {
		$postspercentage = sprintf("%.2f", $memsettings[6] / $totalm * 100);
	} else {
		$postspercentage = sprintf("%.2f", 0);
	}

	if ($memsettings[14] !~ /^\d\d\/\d\d\/\d\d $txt{'107'} \d\d\:\d\d\:\d\d$/ig) {
		$memsettings[14] = $forumstartdate;
	}
	$date1 = $memsettings[14];
	$date2 = $date;
	&calcdifference;
	$result = $result + 1;
	if ($result > 0) {
		$postsperday = sprintf("%.2f", $memsettings[6] / $result);
	} else {
		$postsperday = 0;
	}

################ END ADVANCED POST STATS MOD ################

	if($username ne $INFO{'username'} && $enable_buddies) { $add2bud = qq~<BR><a href="$cgi;action=managebuddies2;addbuddies=$useraccount{$INFO{'username'}}">$imtxt{'37'}</a>.<BR><BR>~; } else { $add2bud = qq~<BR><BR>~; }

	$yymain .= qq~
<table border="0" cellpadding="4" cellspacing="1" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center" width="75%">
  <tr>
    <td class="titlebg" colspan="2" bgcolor="$color{'titlebg'}">
    <table border="0" cellspacing="0" cellpadding="0" width="100%">
      <tr height="30">
	<td width="50%">
        <img src="$imagesdir/profile.gif" alt="" border="0">&nbsp;
        <font size=2 class="text1" color="$color{'titletext'}"><B>$txt{'35'}: $INFO{'username'}</b></font></td>
	<td align="center" width="20%">
        <font size=2 class="text1" color="$color{'titletext'}">$modify</font></td>
	<td align="center" width="30%">
        <font size=2 class="text1" color="$color{'titletext'}">$txt{'232'}</font></td>
      </tr>
    </table>
    </td>
  </tr><tr>
    <td bgcolor="$color{'windowbg'}" class="windowbg" width="70%">
    <table border=0 cellspacing="0" cellpadding="2" width="100%">
      <tr>
	<td><font size=2><b>$txt{'68'}: </b></font></td>
	<td><font size=2>$memsettings[1]</font></td>
      </tr><tr>
        <td><font size=2><b>$txt{'87'}: </b></font></td>
        <td><font size=2>$memberinfo</font></td>
      </tr><tr>
        <td><font size=2><b>$txt{'233'}: </b></font></td>
        <td><font size=2>$dr</font></td>
~;
	if( $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') {
	$yymain .= qq~
      </tr><tr>
        <td><font size=2><b>$amv_txt{'9'}: </b></font></td>
        <td><font size=2>$userlastlogin</font></td>
      </tr><tr>
        <td><font size=2><b>$amv_txt{'10'}: </b></font></td>
        <td><font size=2>$userlastpost</font></td>
      </tr><tr>
        <td><font size=2><b>$amv_txt{'11'}: </b></font></td>
        <td><font size=2>$userlastim</font></td>
~;
}
	$yymain .= qq~
      </tr><tr>
	  <td colspan="2"><a name="lngrf"><hr size="1" width="100%" class="hr"></a></td>
      </tr><tr>
        <td valign="top"><font size=2><b>$txt{'86'}: </b></font></td>
	<td><font size=2><b>$memsettings[6]</b> $profstatxt{'3'}<br>
	  $postspercentage$profstatxt{'1'}<br>
	  $postsperday $profstatxt{'2'}</font></td>
      </tr><tr>
	~;
	require "$sourcedir/LineGraph.pl"; &LineGraph($INFO{'username'});
	$yymain .= qq~
~;
if($gbsettings[0] eq "checked") {

$msgcount = 0;
if(-e ("$memberdir/$INFO{'username'}.gst")) {
	fopen(FILE, "$memberdir/$INFO{'username'}.gst");
	@msglines = <FILE>;
	$mesgcount = @msglines;
	fclose(FILE);
	chomp(@msglines);
	$msgcount = $mesgcount - 1;

	if($INFO{'username'} eq $username && $msglines[$msgcount] > 0) {
		fopen(FILE, ">$memberdir/$username.gst", 1);
		for($i=0;$i<$msgcount;$i++) {
			print FILE "$msglines[$i]\n";
		}
		print FILE "0";
		fclose(FILE);
	}
}
$yymain .= qq~
      </tr><tr>
		<td colspan="2"><a name="gbook"><hr size="1" width="100%" class="hr"></a></td>
      </tr><tr>
		<td colspan="2"><font size=2><b>$gsttxt{'1'}:</b></font></td>
	</tr><tr>
		<td colspan="2">
		<div style="position: relative; top: 0px; left: 0px; width: 340px; height: 140px; margin: 2px; padding: 7px; border-style: inset; border-left-width: 2px; border-right-width: 2px; border-top-width: 2px; border-bottom-width: 2px; overflow: auto;" class="quote">
		~;
		if($username ne "Guest" || $gballowguest && $gbsettings[3] eq "checked") {
		$yymain .= qq~
		<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
		<form action="$cgi;action=memberguest" method="post" name="postmodify">
		<input type="hidden" name="guestname" value="$username">
		<input type="hidden" name="membername" value="$INFO{'username'}">
		<center>
		<textarea style="font-size: 10px; width: 300px; margin: 2px" name="message" cols="57" rows="4" wrap="soft" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);"></textarea>
		<br>
		~;
		if($gb_enable_ubbc) {
			$yymain .= qq~
			<script language="JavaScript1.2" type="text/javascript">
			<!--
			if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {
				document.write("<a href=javascript:smiley()><img src='$imagesdir/smiley.gif' Hspace='2' Vspace='0' align=bottom alt='$txt{'287'}' border='0'></a>");
				document.write("<a href=javascript:grin()><img src='$imagesdir/grin.gif' Hspace='2' Vspace='0' align=bottom alt='$txt{'293'}' border='0'></a>");
				document.write("<a href=javascript:cool()><img src='$imagesdir/cool.gif' Hspace='2' Vspace='0' align=bottom alt='$txt{'295'}' border='0'></a>");
				document.write("<a href=javascript:kiss()><img src='$imagesdir/kiss.gif' Hspace='2' Vspace='0' align=bottom alt='$txt{'529'}' border='0'></a>");
				document.write("<a href=javascript:angry()><img src='$imagesdir/angry.gif' Hspace='2' Vspace='0' align=bottom alt='$txt{'288'}' border='0'></a>");
				document.write("<a href=javascript:embarassed()><img src='$imagesdir/embarassed.gif' Hspace='2' Vspace='0' align=bottom alt='$txt{'526'}' border='0'></a>");
				document.write("<a href=javascript:cry()><img src='$imagesdir/cry.gif' Hspace='2' Vspace='0' align=bottom alt='$txt{'530'}' border='0'></a>");
				document.write("<a href=javascript:lipsrsealed()><img src='$imagesdir/lipsrsealed.gif' Hspace='2' Vspace='0' align=bottom alt='$txt{'527'}' border='0'></a>");
			}
			else { document.write("<font size='1'>$txt{'215'}</font>"); }
			//-->
			</script>
			<noscript>
			<font size="1">$txt{'215'}</font>
			</noscript>
			~;
			}
			if($gb_enable_ubbc) {
			$yymain .= qq~
			<script language="JavaScript1.2" type="text/javascript">
			<!--
			if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3) || (navigator.appName == "Konqueror" && navigator.appVersion.charAt(0) >= 2)) {
				document.write("<a href=javascript:bold()><img src='$imagesdir/bold.gif' align=absmiddle width=23 height=22 alt='$txt{'253'}' border=0></a>");
				document.write("<a href=javascript:italicize()><img src='$imagesdir/italicize.gif' align=absmiddle width=23 height=22 alt='$txt{'254'}' border='0'></a>");
				document.write("<a href=javascript:underline()><img src='$imagesdir/underline.gif' align=absmiddle width=23 height=22 alt='$txt{'255'}' border='0'></a>");
			}
			else { document.write("<font size='1'>$txt{'215'}</font>"); }
			//-->
			</script>
			<noscript>
				<font size="1">$txt{'215'}</font>
			</noscript>
			~;
		}
		$yymain .= qq~
		<input value="$gbsettings[2]" name="msgCL" style="width:33px; font-size: 12px" disabled>
		<input type="submit" value="$gsttxt{'2'}" style="width:35px; font-size: 12px">
		</center>
		<script language="JavaScript">
		<!--
			var supportsKeys = false
			function tick() {
				calcCharLeft(document.forms[0])
				if (!supportsKeys) timerID = setTimeout("tick()",$gbsettings[2])
			}

			function calcCharLeft(sig) {
				clipped = false
				maxLength = $gbsettings[2]
				if (document.postmodify.message.value.length > maxLength) {
					document.postmodify.message.value = document.postmodify.message.value.substring(0,maxLength)
					charleft = 0
					clipped = true
			  	}
				else {
					charleft = maxLength - document.postmodify.message.value.length
			  	}
				document.postmodify.msgCL.value = charleft
				return clipped
			}
			tick();
		//-->
		</script>
		~;
		}
		$yymain .= qq~
		<hr size="1" width="100%" class="hr">
			<font size="1"><b>$txt{'21'}:</b> $msgcount</font>
		<hr size="1" width="100%" class="hr">
		~;
		for($i=0;$i<$msgcount;$i++) {
			$x=$msgcount-$i;
			my($thisdate, $thisname, $thismesg);
			($gdate, $gname, $gmesg) = split(/\|/, $msglines[$i]);
			$thisdate = &timeformat($gdate);
			if($gname eq "Guest") { $thisname .= qq(<b>$txt{'28'}</b>); $tempname = $thisname; }
			else {
				fopen(FILE, "$memberdir/$gname.dat");
				@gsetting = <FILE>;
				fclose(FILE);
				chomp(@gsetting);
				$thisname .= qq(<a href="$cgi;action=viewprofile;username=$gname"><b>$gsetting[1]</b></a>);
				$tempname = $gsetting[1];
			}
			$thismesg = $gmesg;
			$thismesg =~ s~\&\&~<br>~g;
			$message = $thismesg;
			&wrap;
			$displayname = $tempname;
			if($gb_enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
			&wrap2;
			$thismesg = $message;
			if ($username eq $INFO{'username'} || $settings[7] eq "Administrator") {
				$delgst = qq~<a href="$cgi;action=memberguestdel;delpost=$i"><font size=1>$gsttxt{'3'}</font></a>~;
			}
			$yymain .= qq~
				<font size="1" face="Verdana" style="line-height: 18pt">$thisname <b>- $thisdate</b></font><br>
				<font size="1" face="Verdana">$thismesg</font>
			~;
			if ($username eq $INFO{'username'} || $settings[7] eq "Administrator") {
			$yymain .= qq~
			<br>
				<font size="1" face="Verdana" style="line-height: 18pt"><b>$gsttxt{'4'}</b> $x</font></a> -
				<a href="$cgi;action=memberguestdel;profilen=$INFO{'username'};delpost=$i"><font size="1" face="Verdana" style="line-height: 18pt">$gsttxt{'3'}</font></a>
			~;
			}
			$yymain .= qq~
				<hr size="1" width="100%" class="hr">
		~;
		}
		$yymain .= qq~
		</form>
		</div>
	</td>
	~;
	if ($username eq $INFO{'username'} || $settings[7] eq "Administrator") {
	$yymain .= qq~

	</tr><tr>
		<td align="left" valign="middle">
			<font size="2"><b>$gsttxt{'10'}:</b></font>
		</td>
		<td align="left" valign="bottom">
			<table cellspacing="0" cellpadding="1">
			<form action="$cgi;action=memberguestmultidel" method="post">
			<input type="hidden" name="membername" value="$INFO{'username'}">
			<tr>
				<td align="center"><font size="1">$gsttxt{'7'}</font></td>
				<td align="center"><font size="1">$gsttxt{'8'}</font></td>
				<td align="center"><font size="1">&nbsp;</font></td>
			</tr>
			<tr>
				<td align="center"><input type="text" name="fromdel" style="width:35px; font-size: 12px"></td>
				<td align="center"><input type="text" name="todel" style="width:35px; font-size: 12px"></td>
				<td align="center"><input type="submit" value="$gsttxt{'3'}" style="font-size: 12px"></td>
			</tr>
			</form>
			</table>
		</td>
	</tr><tr>
		<td colspan="2" align="left" valign="top">
			<table cellspacing="0" cellpadding="0" width="350">
			<tr>
				<td><font size="1">$gsttxt{'9'}</font></td>
			</tr>
			</table>
		</td>
	~;
	}
}
$yymain .= qq~
      </tr>
~;
require "$sourcedir/ExtendedProfiles.pl";
$yymain .= ext_viewprofile($INFO{'username'}) . qq~<tr>
	<td colspan="2"><hr size="1" width="100%" class="hr"></td>
      </tr><tr>
        <td><font size=2><b>$txt{'513'}:</b></font></td>
        <td><font size=2>~;
        if( $memsettings[8] ne "" && $memsettings[8] !~ m~\D~ ) {$yymain .= qq~ <img src="http://web.icq.com/whitepages/online?icq=$memsettings[8]&img=5" alt="$memsettings[8]" border="0"> <a href="$cgi;action=icqpager;UIN=$icq" target=_blank>$memsettings[8]</a>~;}
	$yymain .= qq~
        </font></td>
      </tr><tr>
        <td><font size=2><b>$txt{'603'}: </b></font></td>
        <td><font size=2><a href="aim:goim?screenname=$memsettings[9]&message=Hi,+are+you+there?">$memsettingsd[9]</a></font></td>
      </tr><tr>
        <td><font size=2><b>$txt{'604'}: </b></font></td>
        <td><font size=2>~;
     if( $memsettings[10] ne "") {$yymain .= qq~ <img src="http://opi.yahoo.com/online?u=$memsettings[10]&m=g&t=0" NOSAVE BORDER=0 alt="$memsettings[10]"> <a href="http://edit.yahoo.com/config/send_webmesg?.target=$memsettings[10]">$memsettingsd[10]</a></font></td></tr>~;}
        else {$yymain .= qq~ </font></td></tr>~;}

	fopen(FILE, "$memberdir/$INFO{'username'}.om", 1);
		@msnsettings = <FILE>;
	fclose <FILE>;
	chomp @msnsettings;
	if($msnsettings[0] ne "") {
	$yymain .= qq~

      <tr>
	<td><font size="2"><b>$msntxt{'4'}: </b></font></td>
	<td>
	<img src="$imagesdir/msn2.gif" style="cursor: hand" onclick="window.open('$cgi;action=setmsn;msnname=$msnsettings[0]','','height=50,width=340,menubar=no,toolbar=no,scrollbars=no'); return false" alt="$msnsettings[0]" border="0" />
	<a href="#" onclick="window.open('$cgi;action=setmsn;msnname=$msnsettings[0]','','height=80,width=340,menubar=no,toolbar=no,scrollbars=no'); return false">$msnsettings[0]</a>
	</td></tr>
~;
	}
$yymain .= qq~
	<td><font size=2><b>$txt{'69'}: </b></font></td>
	<td><font size=2>$email</font></td>
      </tr><tr>
        <td><font size=2><b>$txt{'96'}: </b></font></td>
        <td><font size=2><a href="$memsettings[4]" target=_blank>$memsettings[3]</a></font></td>
      </tr><tr>
        <td><font size=2><b>$hp_txt{'1'}: </b></font></td>
        <td><font size=2>$homepage_link</font></td>
      </tr><tr>
	<td colspan="2"><hr size="1" width="100%" class="hr"></td>
      </tr><tr>
	<td><font size=2><b>$txt{'231'}: </b></font></td>
	<td><font size=2>$gender</font></td>
      </tr><tr>
        <td><font size=2><b>$txt{'420'}:</b></font></td>
        <td><font size=2>$age</font> &nbsp; $isbday</td>
      </tr><tr>
	<td><font size=2><b>$modtxt{'1'}: </b></font></td>
	<td><font size=2>$moodimg</font></td>
      </tr><tr>
        <td><font size=2><b>$txtrst{'0'}:</b></font></td>
        <td><font size=2>$rsttxt</font></td>
      </tr><tr>
<script language="JavaScript1.2" type="text/javascript">
<!--
	function MapEditwin(FileName,WindowName) {
		WindowFeature="Resizable=No,ScrollBars=No,MenuBar=No,Directories=No,ToolBar=No,Location=No,Status=No,Width=762,Height=431,ScreenX=0,ScreenY=0,Top=0,Left=0"
		newWindow=open(FileName,WindowName,WindowFeature);
		if (newWindow.opener == null) { newWindow.opener = self; }
		if (newWindow.focus) { newWindow.focus(); }
	}
//-->
</script>
~;
if($view_mapgender) {
	if($memsettings[11] eq "Male") {
		$pin = "bpin";
	}
	elsif($memsettings[11] eq "Female") {
		$pin = "rpin";
	}
	else {
		$pin = "gpin";
	}
}
else {
	$pin = $mappin;
}

my($loccode, $memblocal, $membcountry, $membcontinent, $membx, $memby, $membstate, $initstate, $namestate, $viewmembname, $viewloc);
$membx = 0; $memby = 0; $membcontinent = "";
($loccode, $memblocal, $membcountry, $membcontinent, $membx, $memby, $membstate) = split(/\|/, $memsettings[15]);
($initstate, $namestate) = split(/\,/, $membstate);
my($prlocal, $inistate);
if($memblocal ne "") { $prlocal .= qq~$memblocal,~; } else { $prlocal = ""; }
if($initstate ne "") { $inistate .= qq~$initstate,~; } else { $inistate = ""; }

if($view_flag) {
	if($membcountry ne "") { $theflag = qq~<img src="$imagesdir/flag/$membcountry.gif" border="0" hspace="5" align="absmiddle">~; }
}
else { $theflag = ""; }

$thiscountry = $membcountry;
$thiscountry =~ s/\_/ /g;

if($loccode eq "x0" || $loccode eq "x1") {
	my($thislocal, $thisstate);
	if($memblocal ne "") { $thislocal .= qq~$memblocal,~; }
	else { $thislocal = ""; }
	if($initstate ne "") { $thisstate .= qq~$initstate,~; }
	else { $thisstate = ""; }
	$viewloc = qq~<font size=2>$thislocal $thisstate $thiscountry</font>$theflag~;
}
else { $viewloc = qq~<font size=2>&nbsp;</font>~; }

if($loccode eq "x1") {
$yymain .= qq~
      </tr>
    </table>
    </td>
    <td bgcolor="$color{'windowbg'}" class="windowbg" valign="middle" align="center" width="30%">
    $pic<BR><BR>
    <font size=1>$memsettings[12]</font></td>
  </tr>
~;

if($membcontinent eq "") {
	fopen(FILE, "$vardir/continent.txt");
	@continent = <FILE>;
	fclose(FILE);
	foreach (@continent) { $_ =~ s~[\n\r]~~g; }
	$memcontinent = lc($continent[0]);
}
else {
	$memcontinent = lc($membcontinent);
}

$yymain .= qq~

<tr>
<td class="titlebg" colspan="2" bgcolor="$color{'titlebg'}">
    <table border="0" cellspacing="0" cellpadding="4" width="100%">
      <tr>
	<td align="left" width="25%">
        <a name="mmap"><font size="2" class="text1" color="$color{'titletext'}">$txt{'227'}:</font></a></td>
	<td align="left" width="45%">
        <font size=2 class="text1" color="$color{'titletext'}">$viewloc</font></td>
	<td align="center" width="30%">
        <font size=2 class="text1" color="$color{'titletext'}">$modifyloc</font></td>
      </tr>
    </table>
</td>
</tr><tr>
<td bgcolor="#F0F0F0" colspan="2" align="center">
<div id="map" style="position: relative; overflow: hidden; background-color: #F0F0F0; width: 550px; height: 430px; cursor: default;">
	<img src="$imagesdir/$memcontinent.gif" id="aktmap" name="mapview" width="550" height="430" style="position: relative; z-index: 0;" GALLERYIMG="no">
	<img src="$imagesdir/$pin.gif" id="memloc" style="z-index: 1; border: 0;">
</div>
</td>
</tr>

<script language="JavaScript1.2" type="text/javascript">

var useNS6 = document.getElementById && !document.all ? 1:0;

	document.images.mapview.src="$imagesdir/$memcontinent.gif";

	if (document.all) {
		document.all.map.style.cursor = "default";
		document.all.memloc.style.position = "absolute";
		document.all.memloc.style.top = $memby - 9;
		document.all.memloc.style.left = $membx - 3;
		document.all.memloc.style.visibility="visible";
	}
	if(useNS6) {
		document.getElementById("map").style.cursor = "default";
		document.getElementById("memloc").style.position = "absolute";
		document.getElementById("memloc").style.top = $memby - 9;
		document.getElementById("memloc").style.left = $membx - 3;
		document.getElementById("memloc").style.visibility = "visible";
	}

</script>
~;
}
else {
$yymain .= qq~
      </tr><tr>
        <td><font size=2><b>$txt{'227'}:</b></font></td>
        <td>$viewloc</td>
      </tr>
      <tr>
        <td>&nbsp;</td>
        <td>$modifyloc1</td>
	</tr>
    </table>
    </td>
    <td bgcolor="$color{'windowbg'}" class="windowbg" valign="middle" align="center" width="30%">
    $pic<BR><BR>
    <font size=1>$memsettings[12]</font></td>
  </tr>
~;
}
$yymain .= qq~
  </tr><tr height="25">
    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2">
    &nbsp;<font size=2 class="text1" color="$color{'titletext'}"><b>$siginprof{'1'}:</b></font></td>
      </tr><tr>~;
    $message = $showursig;
    &wrap;
    if($showursig eq "") { $yymain .= qq~
    <td colspan="2" bgcolor="$color{'windowbg2'}" class="windowbg2" valign="middle" width="100%"><font size=1><i>$siginprof{'2'}</i></font></td>~;
    }
    else { if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
    $yymain .= qq~
        <td colspan="2" bgcolor="$color{'windowbg2'}" class="windowbg2" valign="middle" width="100%"><font size=1><br>$message</font></td>~;
    }
    $yymain .= qq~
  <tr height="25">
    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2">
    &nbsp;<font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'459'}:</b></font></td>
  </tr><tr>
    <td colspan="2" bgcolor="$color{'windowbg2'}" class="windowbg2" valign="middle" width="100%">
    <form action="$cgi;action=usersrecentposts;username=$useraccount{$INFO{'username'}}" method="POST">
    <font size=2>
    $online<BR><BR>
    <a href="$cgi;action=imsend;to=$useraccount{$INFO{'username'}}">$txt{'688'}</a>.
    $add2bud
~;
if($maxrecentdisplay > 0){
        $yymain .= qq~
    $txt{'460'} <select name="viewscount" size="1">
     <option value="5" selected>5</option>
     <option value="10">10</option>
     <option value="15">15</option>
     <option value="$maxrecentdisplay">$maxrecentdisplay</option>
     </select> $txt{'461'}.
     <input type=submit value="$txt{'462'}">
~;
}
        $yymain .= qq~
    </form>
    </font></td>
  </tr>
</table>
~;
	fopen(FILE, "$memberdir/$INFO{'username'}.title");
	@titlesettings=<FILE>;
	fclose(FILE);

	$yytitle = "$txt{'92'} $INFO{'username'}";
	&template;
	exit;
}

sub usersrecentposts {
	my $curuser = $INFO{'username'};
	&FormatUserName($curuser);
	if ($curuser =~ m~/~){ &fatal_error($txt{'224'}); }
	if ($curuser =~ m~\\~){ &fatal_error($txt{'225'}); }
	my $display = $FORM{'viewscount'};
	if( $display =~ /\D/ ) { &fatal_error($txt{'337'}); }
	$display ||= $maxrecentdisplay;
	if($display > $maxrecentdisplay) {$display = $maxrecentdisplay;}
	my( @memset, @categories, %data, %cat, $numfound, $oldestfound, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, $tmpa, %openmemgr, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $mtime, $counter, $board, $notify );

	fopen(FILE, "$memberdir/$curuser.dat") || &fatal_error("$txt{'23'} $curuser.txt");
	@memset = <FILE>;
	fclose(FILE);

	@categories = ();
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

	&LoadCensorList;	# Load Censor List

	$oldestfound = stringtotime("01/10/37 $txt{'107'} 00:00:00");

	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		$openmemgr{$curcat} = 0;
		@membergroups = split( /,/, $cataccess{$curcat} );
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' ) {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) { next; }
		boardcheck: foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			fopen(FILE, "$boardsdir/$curboard.txt");
			@threads = <FILE>;
			fclose(FILE);

			fopen(FILE, "$boardsdir/$curboard.dat");
			@boardinfo = <FILE>;
			fclose(FILE);
			####
			unless ($settings[7] eq "Administrator") {
				my $cookiename = "$cookiepassword$curboard";
				my $crypass = crypt($boardpw{$curboard},$pwseed);
				my $access = &AccessCheck($curboard, '');
				if (($boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) || ($access ne "granted")) { next; }
			}
			####
			chomp @boardinfo;
			@{$boardinfo{$curboard}} = @boardinfo;
			$cat{$curboard} = $curcat;

			threadcheck: for ($i = 0; $i < @threads; $i++) {
				chomp $threads[$i];
				($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$i] );
				fopen(FILE, "$datadir/$tnum.txt") || next;
				@messages = <FILE>;
				fclose(FILE);

				for ($c = 0; $c < @messages; $c++) {
					chomp $messages[$c];
					($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$messages[$c]);
					if ($curuser eq $musername) {
						$mtime = stringtotime($mdate);
						if( $numfound >= $display && $mtime <= $oldestfound ) {
							next boardcheck;
						}
						else {
							$data{$mtime} = [$curboard, $tnum, $c, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns];
							if( $mtime < $oldestfound ) { $oldestfound = $mtime; }
							++$numfound;
						}
					}
				}
			}
		}
	}

	$yymain .= qq~
<p align=left><a href="$cgi;action=viewprofile;username=$useraccount{$curuser}"><font size=2><b>$txt{'92'} $memset[1]</b></font></a></p>
~;
	@messages = sort {$b <=> $a } keys %data;
	if( @messages > $display ) { $#messages = $display - 1; }
	$counter = 1;
	for( $i = 0; $i < @messages; $i++ ) {
		($board, $tnum, $c, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = @{ $data{$messages[$i]} };
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		&wrap;
		$displayname = $mname;
		if($enable_ubbc) { $ns = $mns; if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;
		if($enable_notification) { $notify = qq~$menusep<a href="$scripturl?board=$board;action=notify;thread=$tnum;start=$c">$img{'notify'}</a>~; }
		$mdate = timeformat($mdate);
		$yymain .= qq~
<table border="0" width="100%" cellspacing="1" $color{'bordercolor'}>
  <tr>
    <td align="left" bgcolor="$color{'titlebg'}" class="titlebg"><font class="text1" color="$color{'titletext'}" size="2">&nbsp;$counter&nbsp;</font></td>
    <td width="75%" bgcolor="$color{'titlebg'}" class="titlebg"><font class="text1" color="$color{'titletext'}" size="2"><b>&nbsp;$catname{$cat{$board}} / $boardinfo{$board}->[0] / <a href="$scripturl?board=$board;action=display;num=$tnum;start=$c#$c"><font class="text1" color="$color{'titletext'}" size=2><u>$msub</u></font></a></b></font></td>
    <td align="right" bgcolor="$color{'titlebg'}" class="titlebg" nowrap>&nbsp;<font class="text1" color="$color{'titletext'}" size=2>$mdate&nbsp;</font></td>
  </tr><tr height=80>
    <td colspan="3" bgcolor="$color{'windowbg2'}"  class="windowbg2" valign="top"><font size="2">$message</font></td>
  </tr><tr>
    <td colspan="3" bgcolor="$color{'catbg'}" class="catbg"><font size="2">
    &nbsp;<a href="$scripturl?board=$board;action=post;num=$tnum;start=$c;title=Post+reply">$img{'reply'}</a>$menusep<a href="$scripturl?board=$board;action=post;num=$tnum;quote=$c;title=Post+reply">$img{'replyquote2'}</a>$notify
    </font></td>
  </tr>
</table><br>
~;
		++$counter;
	}
if($counter <= 1) { $yymain .= "<font size=2><B>$txt{'755'}</B></font>"; }
else { $yymain .= qq~
<p align=left><a href="$cgi;action=viewprofile;username=$useraccount{$curuser}"><font size=2><b>$txt{'92'} $memset[1]</b></font></a></p></font>
~; }
	$yytitle = "$txt{'458'} $memset[1]";
	&template;
	exit;
}

sub MemberGuest2 {

$FORM{'message'} =~ s~\n~\&\&~g;
my($key, $value);
while( ($key,$value) = each(%FORM) ) {
	$value =~ s~\A\s+~~;
	$value =~ s~\s+\Z~~;
	$value =~ s~[\n\r]~~g;
	$guestsign{$key} = $value;
}

if($guestsign{'message'} eq "") { &fatal_error("$txt{'78'}"); }

$char_160 = chr(160);
$guestsign{'message'} =~ s~\[img\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~\[url=http\:\/\/$2\]\[img\]$imagesdir/img2.gif\[\/img\]\[\/url\]~isg;

$membername = $guestsign{'membername'};
if($guestsign{'guestname'} eq "Guest") { $guestname = $txt{'28'} }
else { $guestname = $guestsign{'guestname'}; }
$guestname = $guestsign{'guestname'};
$guestmessage = $guestsign{'message'};

if($GbTimeout) {
	my($gbtime,$gbflood_ip,$gbflood_time,$gbflood,$gbflood_memb,@gbfloodcontrol);
	$gbtime = time;
	$gbtimeoutsec = $GbTimeout * 60;
	if (-e "$vardir/gbflood.txt") {
		fopen(FILE, "$vardir/gbflood.txt");
		push(@gbfloodcontrol,"$user_ip|$gbtime|$membername\n");
		while( <FILE> ) {
			chomp($_);
			($gbflood_ip,$gbflood_time,$gbflood_memb) = split(/\|/,$_);
			if($user_ip eq $gbflood_ip && $membername eq $gbflood_memb && $gbtime - $gbflood_time <= $gbtimeoutsec) { $gbflood = 1; }
			elsif( $gbtime - $gbflood_time < $gbtimeoutsec ) { push( @gbfloodcontrol, "$_\n" ); }
		}
		fclose(FILE);
	}
	if($gbflood) {
		if($settings[7] ne 'Administrator' && $guestname ne $membername) { &fatal_error("$gsttxt{'20'} $GbTimeout $gsttxt{'21'}"); }
	}
	fopen(FILE, ">$vardir/gbflood.txt", 1);
	print FILE @gbfloodcontrol;
	fclose(FILE);
}


if(-e ("$memberdir/$membername.gst")) {
	fopen(FILE, "$memberdir/$membername.gst");
	@meslines = <FILE>;
	$mescount = @meslines;
	fclose(FILE);
	chomp(@meslines);
	$mesgcount = $mescount - 1;
	$meslines[$mesgcount]++;
}
else {
	$meslines[0] = 1;
	$mescount = 1;
}

	fopen(FILE, "$memberdir/$membername.gbs");
	@gbsettings=<FILE>;
	fclose(FILE);
	chomp @gbsettings;
	$counttest = $gbsettings[1];

if($mescount > $counttest) { $mescount = $counttest }

fopen(FILE, ">$memberdir/$membername.gst", 1);
print FILE "$date|$guestname|$guestmessage\n";
for($i=0;$i<$mescount;$i++) { print FILE "$meslines[$i]\n"; }
fclose(FILE);

$yySetLocation = qq~$cgi;action=viewprofile;username=$membername~;
&redirectexit;

}


sub MemberGuest3 {

	fopen(FILE, "$memberdir/$INFO{'profilen'}.gst");
	@gstlist = <FILE>;
	$gestnum = @gstlist;
	fclose(FILE);
	chomp(@gstlist);
	$gstnum = $gestnum - 1;
	$newnumb = 0;
	fopen(FILE, ">$memberdir/$INFO{'profilen'}.gst", 1);
	for($i=0;$i<$gstnum;$i++) {
		if($i != $INFO{'delpost'}) { print FILE "$gstlist[$i]\n"; }
	}
	print FILE "$newnumb\n";
	fclose(FILE);

$yySetLocation = qq~$cgi;action=viewprofile;username=$INFO{'profilen'}~;
&redirectexit;
}

sub MemberGuest4 {

	if(!-e ("$memberdir/$FORM{'membername'}.gst")) { &fatal_error("$gsttxt{'6'}"); }

	fopen(FILE, "$memberdir/$FORM{'membername'}.gst");
	@gstlist = <FILE>;
	$gestnum = @gstlist;
	fclose(FILE);
	chomp(@gstlist);
	$gstnum = $gestnum - 1;

	if($gstnum == 0) { &fatal_error("$gsttxt{'6'}"); }

	if($FORM{'fromdel'} eq "") { $FORM{'fromdel'} = 0; ; }
	if($FORM{'todel'} eq "") { $FORM{'todel'} = 0; }

	if($FORM{'fromdel'} !~ /\A[0-9]+\Z/) { &fatal_error("$gsttxt{'5'}"); }
	if($FORM{'todel'} !~ /\A[0-9]+\Z/) { &fatal_error("$gsttxt{'5'}"); }
	if($FORM{'fromdel'} < 1) { &fatal_error("$gsttxt{'5'}"); }
	if($FORM{'todel'} > $gstnum) { &fatal_error("$gsttxt{'5'}"); }
	if($FORM{'fromdel'} > $FORM{'todel'}) { &fatal_error("$gsttxt{'5'}"); }

	$fromdel = $gstnum - $FORM{'todel'};
	$todel = $gstnum - $FORM{'fromdel'};

	$newnumb = 0;
	fopen(FILE, ">$memberdir/$FORM{'membername'}.gst", 1);
	for($i=0;$i<$gstnum;$i++) {
		if($i < $fromdel || $i > $todel) { print FILE "$gstlist[$i]\n"; }
	}
	print FILE "$newnumb\n";
	fclose(FILE);

$yySetLocation = qq~$cgi;action=viewprofile;username=$FORM{'membername'}~;
&redirectexit;
}

1;
